	TITLE	C:\SRC\dfs\dfs.c
	.386P
include listing.inc
if @Version gt 510
.model FLAT
else
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
_DATA	SEGMENT DWORD USE32 PUBLIC 'DATA'
_DATA	ENDS
CONST	SEGMENT DWORD USE32 PUBLIC 'CONST'
CONST	ENDS
_BSS	SEGMENT DWORD USE32 PUBLIC 'BSS'
_BSS	ENDS
$$SYMBOLS	SEGMENT BYTE USE32 'DEBSYM'
$$SYMBOLS	ENDS
$$TYPES	SEGMENT BYTE USE32 'DEBTYP'
$$TYPES	ENDS
_TLS	SEGMENT DWORD USE32 PUBLIC 'TLS'
_TLS	ENDS
;	COMDAT ??_C@_03CGME@dfs?$AA@
CONST	SEGMENT DWORD USE32 PUBLIC 'CONST'
CONST	ENDS
;	COMDAT _dfs_init
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
;	COMDAT _dfs_stat
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
;	COMDAT _dfs_mkdir
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
;	COMDAT _dfs_rmdir
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
;	COMDAT _dfs_rename
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
;	COMDAT _dfs_link
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
;	COMDAT _dfs_unlink
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
FLAT	GROUP _DATA, CONST, _BSS
	ASSUME	CS: FLAT, DS: FLAT, SS: FLAT
endif
PUBLIC	_dfs_stat
PUBLIC	_dfs_mkdir
PUBLIC	_dfs_rmdir
PUBLIC	_dfs_rename
PUBLIC	_dfs_link
PUBLIC	_dfs_unlink
PUBLIC	_dfsops
EXTRN	_dfs_format:NEAR
EXTRN	_dfs_mount:NEAR
EXTRN	_dfs_unmount:NEAR
EXTRN	_dfs_open:NEAR
EXTRN	_dfs_close:NEAR
EXTRN	_dfs_flush:NEAR
EXTRN	_dfs_read:NEAR
EXTRN	_dfs_write:NEAR
EXTRN	_dfs_tell:NEAR
EXTRN	_dfs_lseek:NEAR
EXTRN	_dfs_chsize:NEAR
EXTRN	_dfs_fstat:NEAR
EXTRN	_dfs_opendir:NEAR
EXTRN	_dfs_readdir:NEAR
_DATA	SEGMENT
_dfsops	DD	FLAT:_dfs_format
	DD	FLAT:_dfs_mount
	DD	FLAT:_dfs_unmount
	DD	FLAT:_dfs_open
	DD	FLAT:_dfs_close
	DD	FLAT:_dfs_flush
	DD	FLAT:_dfs_read
	DD	FLAT:_dfs_write
	DD	FLAT:_dfs_tell
	DD	FLAT:_dfs_lseek
	DD	FLAT:_dfs_chsize
	DD	FLAT:_dfs_fstat
	DD	FLAT:_dfs_stat
	DD	FLAT:_dfs_mkdir
	DD	FLAT:_dfs_rmdir
	DD	FLAT:_dfs_rename
	DD	FLAT:_dfs_link
	DD	FLAT:_dfs_unlink
	DD	FLAT:_dfs_opendir
	DD	FLAT:_dfs_readdir
_DATA	ENDS
PUBLIC	_dfs_init
PUBLIC	??_C@_03CGME@dfs?$AA@				; `string'
EXTRN	__chkesp:NEAR
EXTRN	_register_filesystem:NEAR
;	COMDAT ??_C@_03CGME@dfs?$AA@
; File c:\src\dfs\dfs.c
CONST	SEGMENT
??_C@_03CGME@dfs?$AA@ DB 'dfs', 00H			; `string'
CONST	ENDS
;	COMDAT _dfs_init
_TEXT	SEGMENT
_dfs_init PROC NEAR					; COMDAT

; 68   : {

	push	ebp
	mov	ebp, esp
	sub	esp, 64					; 00000040H
	push	ebx
	push	esi
	push	edi
	lea	edi, DWORD PTR [ebp-64]
	mov	ecx, 16					; 00000010H
	mov	eax, -858993460				; ccccccccH
	rep stosd

; 69   :   register_filesystem("dfs", &dfsops);

	push	OFFSET FLAT:_dfsops
	push	OFFSET FLAT:??_C@_03CGME@dfs?$AA@	; `string'
	call	_register_filesystem
	add	esp, 8

; 70   : }

	pop	edi
	pop	esi
	pop	ebx
	add	esp, 64					; 00000040H
	cmp	ebp, esp
	call	__chkesp
	mov	esp, ebp
	pop	ebp
	ret	0
_dfs_init ENDP
_TEXT	ENDS
EXTRN	_strlen:NEAR
EXTRN	_time:NEAR
EXTRN	_get_inode:NEAR
EXTRN	_release_inode:NEAR
EXTRN	_lookup_name:NEAR
;	COMDAT _dfs_stat
_TEXT	SEGMENT
_fs$ = 8
_name$ = 12
_buffer$ = 16
_ino$ = -4
_inode$ = -8
_dfs_stat PROC NEAR					; COMDAT

; 73   : {

	push	ebp
	mov	ebp, esp
	sub	esp, 72					; 00000048H
	push	ebx
	push	esi
	push	edi
	lea	edi, DWORD PTR [ebp-72]
	mov	ecx, 18					; 00000012H
	mov	eax, -858993460				; ccccccccH
	rep stosd

; 74   :   ino_t ino;
; 75   :   struct inode *inode;
; 76   : 
; 77   :   ino = lookup_name((struct filsys *) fs->data, DFS_INODE_ROOT, name, strlen(name));

	mov	eax, DWORD PTR _name$[ebp]
	push	eax
	call	_strlen
	add	esp, 4
	push	eax
	mov	ecx, DWORD PTR _name$[ebp]
	push	ecx
	push	0
	mov	edx, DWORD PTR _fs$[ebp]
	mov	eax, DWORD PTR [edx+272]
	push	eax
	call	_lookup_name
	add	esp, 16					; 00000010H
	mov	DWORD PTR _ino$[ebp], eax

; 78   :   if (ino == -1) return -1;

	cmp	DWORD PTR _ino$[ebp], -1
	jne	SHORT $L997
	or	eax, -1
	jmp	$L993
$L997:

; 79   : 
; 80   :   inode = get_inode((struct filsys *) fs->data, ino);

	mov	ecx, DWORD PTR _ino$[ebp]
	push	ecx
	mov	edx, DWORD PTR _fs$[ebp]
	mov	eax, DWORD PTR [edx+272]
	push	eax
	call	_get_inode
	add	esp, 8
	mov	DWORD PTR _inode$[ebp], eax

; 81   :   if (!inode) return -1;

	cmp	DWORD PTR _inode$[ebp], 0
	jne	SHORT $L999
	or	eax, -1
	jmp	$L993
$L999:

; 82   : 
; 83   :   buffer->mode = 0;

	mov	ecx, DWORD PTR _buffer$[ebp]
	mov	DWORD PTR [ecx], 0

; 84   :   if (inode->desc->flags & DFS_INODE_FLAG_DIRECTORY) buffer->mode |= FS_DIRECTORY;

	mov	edx, DWORD PTR _inode$[ebp]
	mov	eax, DWORD PTR [edx+8]
	mov	ecx, DWORD PTR [eax]
	and	ecx, 1
	test	ecx, ecx
	je	SHORT $L1000
	mov	edx, DWORD PTR _buffer$[ebp]
	mov	eax, DWORD PTR [edx]
	or	al, 1
	mov	ecx, DWORD PTR _buffer$[ebp]
	mov	DWORD PTR [ecx], eax
$L1000:

; 85   : 
; 86   :   buffer->ino = ino;

	mov	edx, DWORD PTR _buffer$[ebp]
	mov	eax, DWORD PTR _ino$[ebp]
	mov	DWORD PTR [edx+4], eax

; 87   :   buffer->atime = time(NULL);

	push	0
	call	_time
	add	esp, 4
	mov	ecx, DWORD PTR _buffer$[ebp]
	mov	DWORD PTR [ecx+8], eax

; 88   :   buffer->mtime = inode->desc->mtime;

	mov	edx, DWORD PTR _inode$[ebp]
	mov	eax, DWORD PTR [edx+8]
	mov	ecx, DWORD PTR _buffer$[ebp]
	mov	edx, DWORD PTR [eax+8]
	mov	DWORD PTR [ecx+12], edx

; 89   :   buffer->ctime = inode->desc->ctime;

	mov	eax, DWORD PTR _inode$[ebp]
	mov	ecx, DWORD PTR [eax+8]
	mov	edx, DWORD PTR _buffer$[ebp]
	mov	eax, DWORD PTR [ecx+4]
	mov	DWORD PTR [edx+16], eax

; 90   :   
; 91   :   buffer->quad.size_low = inode->desc->size;

	mov	ecx, DWORD PTR _inode$[ebp]
	mov	edx, DWORD PTR [ecx+8]
	mov	eax, DWORD PTR _buffer$[ebp]
	mov	ecx, DWORD PTR [edx+12]
	mov	DWORD PTR [eax+24], ecx

; 92   :   buffer->quad.size_high = 0;

	mov	edx, DWORD PTR _buffer$[ebp]
	mov	DWORD PTR [edx+28], 0

; 93   : 
; 94   :   release_inode(inode);

	mov	eax, DWORD PTR _inode$[ebp]
	push	eax
	call	_release_inode
	add	esp, 4

; 95   : 
; 96   :   return 0;

	xor	eax, eax
$L993:

; 97   : }

	pop	edi
	pop	esi
	pop	ebx
	add	esp, 72					; 00000048H
	cmp	ebp, esp
	call	__chkesp
	mov	esp, ebp
	pop	ebp
	ret	0
_dfs_stat ENDP
_TEXT	ENDS
EXTRN	_mark_inode_dirty:NEAR
EXTRN	_alloc_inode:NEAR
EXTRN	_unlink_inode:NEAR
EXTRN	_find_dir_entry:NEAR
EXTRN	_parse_name:NEAR
EXTRN	_add_dir_entry:NEAR
;	COMDAT _dfs_mkdir
_TEXT	SEGMENT
_fs$ = 8
_name$ = 12
_parent$ = -4
_dir$ = -8
_len$ = -12
_dfs_mkdir PROC NEAR					; COMDAT

; 100  : {

	push	ebp
	mov	ebp, esp
	sub	esp, 76					; 0000004cH
	push	ebx
	push	esi
	push	edi
	lea	edi, DWORD PTR [ebp-76]
	mov	ecx, 19					; 00000013H
	mov	eax, -858993460				; ccccccccH
	rep stosd

; 101  :   struct inode *parent;
; 102  :   struct inode *dir;
; 103  :   int len;
; 104  : 
; 105  :   len = strlen(name);

	mov	eax, DWORD PTR _name$[ebp]
	push	eax
	call	_strlen
	add	esp, 4
	mov	DWORD PTR _len$[ebp], eax

; 106  :   parent = parse_name((struct filsys *) fs->data, &name, &len);

	lea	ecx, DWORD PTR _len$[ebp]
	push	ecx
	lea	edx, DWORD PTR _name$[ebp]
	push	edx
	mov	eax, DWORD PTR _fs$[ebp]
	mov	ecx, DWORD PTR [eax+272]
	push	ecx
	call	_parse_name
	add	esp, 12					; 0000000cH
	mov	DWORD PTR _parent$[ebp], eax

; 107  :   if (!parent) return -1;

	cmp	DWORD PTR _parent$[ebp], 0
	jne	SHORT $L1011
	or	eax, -1
	jmp	$L1006
$L1011:

; 108  : 
; 109  :   if (find_dir_entry(parent, name, len) != -1)

	mov	edx, DWORD PTR _len$[ebp]
	push	edx
	mov	eax, DWORD PTR _name$[ebp]
	push	eax
	mov	ecx, DWORD PTR _parent$[ebp]
	push	ecx
	call	_find_dir_entry
	add	esp, 12					; 0000000cH
	cmp	eax, -1
	je	SHORT $L1012

; 111  :     release_inode(parent);

	mov	edx, DWORD PTR _parent$[ebp]
	push	edx
	call	_release_inode
	add	esp, 4

; 112  :     return -1;

	or	eax, -1
	jmp	$L1006
$L1012:

; 114  : 
; 115  :   dir = alloc_inode(parent, DFS_INODE_FLAG_DIRECTORY);

	push	1
	mov	eax, DWORD PTR _parent$[ebp]
	push	eax
	call	_alloc_inode
	add	esp, 8
	mov	DWORD PTR _dir$[ebp], eax

; 116  :   if (!dir)

	cmp	DWORD PTR _dir$[ebp], 0
	jne	SHORT $L1013

; 118  :     release_inode(parent);

	mov	ecx, DWORD PTR _parent$[ebp]
	push	ecx
	call	_release_inode
	add	esp, 4

; 119  :     return -1;

	or	eax, -1
	jmp	$L1006
$L1013:

; 121  : 
; 122  :   dir->desc->linkcount++;

	mov	edx, DWORD PTR _dir$[ebp]
	mov	eax, DWORD PTR [edx+8]
	mov	ecx, DWORD PTR [eax+16]
	add	ecx, 1
	mov	edx, DWORD PTR _dir$[ebp]
	mov	eax, DWORD PTR [edx+8]
	mov	DWORD PTR [eax+16], ecx

; 123  :   mark_inode_dirty(dir);

	mov	ecx, DWORD PTR _dir$[ebp]
	push	ecx
	call	_mark_inode_dirty
	add	esp, 4

; 124  : 
; 125  :   if (add_dir_entry(parent, name, len, dir->ino) < 0)

	mov	edx, DWORD PTR _dir$[ebp]
	mov	eax, DWORD PTR [edx+4]
	push	eax
	mov	ecx, DWORD PTR _len$[ebp]
	push	ecx
	mov	edx, DWORD PTR _name$[ebp]
	push	edx
	mov	eax, DWORD PTR _parent$[ebp]
	push	eax
	call	_add_dir_entry
	add	esp, 16					; 00000010H
	test	eax, eax
	jge	SHORT $L1014

; 127  :     unlink_inode(dir);

	mov	ecx, DWORD PTR _dir$[ebp]
	push	ecx
	call	_unlink_inode
	add	esp, 4

; 128  :     release_inode(dir);

	mov	edx, DWORD PTR _dir$[ebp]
	push	edx
	call	_release_inode
	add	esp, 4

; 129  :     release_inode(parent);

	mov	eax, DWORD PTR _parent$[ebp]
	push	eax
	call	_release_inode
	add	esp, 4

; 130  :     return -1;

	or	eax, -1
	jmp	SHORT $L1006
$L1014:

; 132  : 
; 133  :   release_inode(dir);

	mov	ecx, DWORD PTR _dir$[ebp]
	push	ecx
	call	_release_inode
	add	esp, 4

; 134  :   release_inode(parent);

	mov	edx, DWORD PTR _parent$[ebp]
	push	edx
	call	_release_inode
	add	esp, 4

; 135  :   return 0;

	xor	eax, eax
$L1006:

; 136  : }

	pop	edi
	pop	esi
	pop	ebx
	add	esp, 76					; 0000004cH
	cmp	ebp, esp
	call	__chkesp
	mov	esp, ebp
	pop	ebp
	ret	0
_dfs_mkdir ENDP
_TEXT	ENDS
EXTRN	_delete_dir_entry:NEAR
;	COMDAT _dfs_rmdir
_TEXT	SEGMENT
_fs$ = 8
_name$ = 12
_parent$ = -4
_dir$ = -8
_ino$ = -12
_len$ = -16
_dfs_rmdir PROC NEAR					; COMDAT

; 139  : {

	push	ebp
	mov	ebp, esp
	sub	esp, 80					; 00000050H
	push	ebx
	push	esi
	push	edi
	lea	edi, DWORD PTR [ebp-80]
	mov	ecx, 20					; 00000014H
	mov	eax, -858993460				; ccccccccH
	rep stosd

; 140  :   struct inode *parent;
; 141  :   struct inode *dir;
; 142  :   ino_t ino;
; 143  :   int len;
; 144  : 
; 145  :   len = strlen(name);

	mov	eax, DWORD PTR _name$[ebp]
	push	eax
	call	_strlen
	add	esp, 4
	mov	DWORD PTR _len$[ebp], eax

; 146  :   parent = parse_name((struct filsys *) fs->data, &name, &len);

	lea	ecx, DWORD PTR _len$[ebp]
	push	ecx
	lea	edx, DWORD PTR _name$[ebp]
	push	edx
	mov	eax, DWORD PTR _fs$[ebp]
	mov	ecx, DWORD PTR [eax+272]
	push	ecx
	call	_parse_name
	add	esp, 12					; 0000000cH
	mov	DWORD PTR _parent$[ebp], eax

; 147  :   if (!parent) return -1;

	cmp	DWORD PTR _parent$[ebp], 0
	jne	SHORT $L1025
	or	eax, -1
	jmp	$L1019
$L1025:

; 148  : 
; 149  :   ino = find_dir_entry(parent, name, len);

	mov	edx, DWORD PTR _len$[ebp]
	push	edx
	mov	eax, DWORD PTR _name$[ebp]
	push	eax
	mov	ecx, DWORD PTR _parent$[ebp]
	push	ecx
	call	_find_dir_entry
	add	esp, 12					; 0000000cH
	mov	DWORD PTR _ino$[ebp], eax

; 150  :   if (ino == -1 || ino == DFS_INODE_ROOT)

	cmp	DWORD PTR _ino$[ebp], -1
	je	SHORT $L1027
	cmp	DWORD PTR _ino$[ebp], 0
	jne	SHORT $L1026
$L1027:

; 152  :     release_inode(parent);

	mov	edx, DWORD PTR _parent$[ebp]
	push	edx
	call	_release_inode
	add	esp, 4

; 153  :     return -1;

	or	eax, -1
	jmp	$L1019
$L1026:

; 155  : 
; 156  :   dir = get_inode(parent->fs, ino);

	mov	eax, DWORD PTR _ino$[ebp]
	push	eax
	mov	ecx, DWORD PTR _parent$[ebp]
	mov	edx, DWORD PTR [ecx]
	push	edx
	call	_get_inode
	add	esp, 8
	mov	DWORD PTR _dir$[ebp], eax

; 157  :   if (!dir)

	cmp	DWORD PTR _dir$[ebp], 0
	jne	SHORT $L1028

; 159  :     release_inode(parent);

	mov	eax, DWORD PTR _parent$[ebp]
	push	eax
	call	_release_inode
	add	esp, 4

; 160  :     return -1;

	or	eax, -1
	jmp	$L1019
$L1028:

; 162  : 
; 163  :   if (!(dir->desc->flags & DFS_INODE_FLAG_DIRECTORY) || dir->desc->size > 0)

	mov	ecx, DWORD PTR _dir$[ebp]
	mov	edx, DWORD PTR [ecx+8]
	mov	eax, DWORD PTR [edx]
	and	eax, 1
	test	eax, eax
	je	SHORT $L1030
	mov	ecx, DWORD PTR _dir$[ebp]
	mov	edx, DWORD PTR [ecx+8]
	cmp	DWORD PTR [edx+12], 0
	jbe	SHORT $L1029
$L1030:

; 165  :     release_inode(dir);

	mov	eax, DWORD PTR _dir$[ebp]
	push	eax
	call	_release_inode
	add	esp, 4

; 166  :     release_inode(parent);

	mov	ecx, DWORD PTR _parent$[ebp]
	push	ecx
	call	_release_inode
	add	esp, 4

; 167  :     return -1;

	or	eax, -1
	jmp	SHORT $L1019
$L1029:

; 169  : 
; 170  :   if (delete_dir_entry(parent, name, len) < 0)

	mov	edx, DWORD PTR _len$[ebp]
	push	edx
	mov	eax, DWORD PTR _name$[ebp]
	push	eax
	mov	ecx, DWORD PTR _parent$[ebp]
	push	ecx
	call	_delete_dir_entry
	add	esp, 12					; 0000000cH
	test	eax, eax
	jge	SHORT $L1031

; 172  :     release_inode(dir);

	mov	edx, DWORD PTR _dir$[ebp]
	push	edx
	call	_release_inode
	add	esp, 4

; 173  :     release_inode(parent);

	mov	eax, DWORD PTR _parent$[ebp]
	push	eax
	call	_release_inode
	add	esp, 4

; 174  :     return -1;

	or	eax, -1
	jmp	SHORT $L1019
$L1031:

; 176  : 
; 177  :   if (unlink_inode(dir) < 0)

	mov	ecx, DWORD PTR _dir$[ebp]
	push	ecx
	call	_unlink_inode
	add	esp, 4
	test	eax, eax
	jge	SHORT $L1032

; 179  :     release_inode(dir);

	mov	edx, DWORD PTR _dir$[ebp]
	push	edx
	call	_release_inode
	add	esp, 4

; 180  :     release_inode(parent);

	mov	eax, DWORD PTR _parent$[ebp]
	push	eax
	call	_release_inode
	add	esp, 4

; 181  :     return -1;

	or	eax, -1
	jmp	SHORT $L1019
$L1032:

; 183  : 
; 184  :   release_inode(dir);

	mov	ecx, DWORD PTR _dir$[ebp]
	push	ecx
	call	_release_inode
	add	esp, 4

; 185  :   release_inode(parent);

	mov	edx, DWORD PTR _parent$[ebp]
	push	edx
	call	_release_inode
	add	esp, 4

; 186  :   return 0;

	xor	eax, eax
$L1019:

; 187  : }

	pop	edi
	pop	esi
	pop	ebx
	add	esp, 80					; 00000050H
	cmp	ebp, esp
	call	__chkesp
	mov	esp, ebp
	pop	ebp
	ret	0
_dfs_rmdir ENDP
_TEXT	ENDS
;	COMDAT _dfs_rename
_TEXT	SEGMENT
_fs$ = 8
_oldname$ = 12
_newname$ = 16
_inode$ = -4
_oldparent$ = -8
_newparent$ = -12
_oldlen$ = -16
_newlen$ = -20
_ino$ = -24
_dfs_rename PROC NEAR					; COMDAT

; 190  : {

	push	ebp
	mov	ebp, esp
	sub	esp, 88					; 00000058H
	push	ebx
	push	esi
	push	edi
	lea	edi, DWORD PTR [ebp-88]
	mov	ecx, 22					; 00000016H
	mov	eax, -858993460				; ccccccccH
	rep stosd

; 191  :   struct inode *inode;
; 192  :   struct inode *oldparent;
; 193  :   struct inode *newparent;
; 194  :   int oldlen;
; 195  :   int newlen;
; 196  :   ino_t ino;
; 197  : 
; 198  :   oldlen = strlen(oldname);

	mov	eax, DWORD PTR _oldname$[ebp]
	push	eax
	call	_strlen
	add	esp, 4
	mov	DWORD PTR _oldlen$[ebp], eax

; 199  :   oldparent = parse_name((struct filsys *) fs->data, &oldname, &oldlen);

	lea	ecx, DWORD PTR _oldlen$[ebp]
	push	ecx
	lea	edx, DWORD PTR _oldname$[ebp]
	push	edx
	mov	eax, DWORD PTR _fs$[ebp]
	mov	ecx, DWORD PTR [eax+272]
	push	ecx
	call	_parse_name
	add	esp, 12					; 0000000cH
	mov	DWORD PTR _oldparent$[ebp], eax

; 200  :   if (!oldparent) return -1;

	cmp	DWORD PTR _oldparent$[ebp], 0
	jne	SHORT $L1047
	or	eax, -1
	jmp	$L1039
$L1047:

; 201  : 
; 202  :   ino = find_dir_entry(oldparent, oldname, oldlen);

	mov	edx, DWORD PTR _oldlen$[ebp]
	push	edx
	mov	eax, DWORD PTR _oldname$[ebp]
	push	eax
	mov	ecx, DWORD PTR _oldparent$[ebp]
	push	ecx
	call	_find_dir_entry
	add	esp, 12					; 0000000cH
	mov	DWORD PTR _ino$[ebp], eax

; 203  :   if (ino == -1) 

	cmp	DWORD PTR _ino$[ebp], -1
	jne	SHORT $L1048

; 205  :     release_inode(oldparent);

	mov	edx, DWORD PTR _oldparent$[ebp]
	push	edx
	call	_release_inode
	add	esp, 4

; 206  :     return -1;

	or	eax, -1
	jmp	$L1039
$L1048:

; 208  : 
; 209  :   inode = get_inode(oldparent->fs, ino);

	mov	eax, DWORD PTR _ino$[ebp]
	push	eax
	mov	ecx, DWORD PTR _oldparent$[ebp]
	mov	edx, DWORD PTR [ecx]
	push	edx
	call	_get_inode
	add	esp, 8
	mov	DWORD PTR _inode$[ebp], eax

; 210  :   if (!inode)

	cmp	DWORD PTR _inode$[ebp], 0
	jne	SHORT $L1049

; 212  :     release_inode(oldparent);

	mov	eax, DWORD PTR _oldparent$[ebp]
	push	eax
	call	_release_inode
	add	esp, 4

; 213  :     return -1;

	or	eax, -1
	jmp	$L1039
$L1049:

; 215  : 
; 216  :   newlen = strlen(newname);

	mov	ecx, DWORD PTR _newname$[ebp]
	push	ecx
	call	_strlen
	add	esp, 4
	mov	DWORD PTR _newlen$[ebp], eax

; 217  :   newparent = parse_name((struct filsys *) fs->data, &newname, &newlen);

	lea	edx, DWORD PTR _newlen$[ebp]
	push	edx
	lea	eax, DWORD PTR _newname$[ebp]
	push	eax
	mov	ecx, DWORD PTR _fs$[ebp]
	mov	edx, DWORD PTR [ecx+272]
	push	edx
	call	_parse_name
	add	esp, 12					; 0000000cH
	mov	DWORD PTR _newparent$[ebp], eax

; 218  :   if (!newparent) 

	cmp	DWORD PTR _newparent$[ebp], 0
	jne	SHORT $L1051

; 220  :     release_inode(inode);

	mov	eax, DWORD PTR _inode$[ebp]
	push	eax
	call	_release_inode
	add	esp, 4

; 221  :     release_inode(oldparent);

	mov	ecx, DWORD PTR _oldparent$[ebp]
	push	ecx
	call	_release_inode
	add	esp, 4

; 222  :     return -1;

	or	eax, -1
	jmp	$L1039
$L1051:

; 224  : 
; 225  :   if (add_dir_entry(newparent, newname, newlen, inode->ino) < 0)

	mov	edx, DWORD PTR _inode$[ebp]
	mov	eax, DWORD PTR [edx+4]
	push	eax
	mov	ecx, DWORD PTR _newlen$[ebp]
	push	ecx
	mov	edx, DWORD PTR _newname$[ebp]
	push	edx
	mov	eax, DWORD PTR _newparent$[ebp]
	push	eax
	call	_add_dir_entry
	add	esp, 16					; 00000010H
	test	eax, eax
	jge	SHORT $L1052

; 227  :     release_inode(inode);

	mov	ecx, DWORD PTR _inode$[ebp]
	push	ecx
	call	_release_inode
	add	esp, 4

; 228  :     release_inode(oldparent);

	mov	edx, DWORD PTR _oldparent$[ebp]
	push	edx
	call	_release_inode
	add	esp, 4

; 229  :     release_inode(newparent);

	mov	eax, DWORD PTR _newparent$[ebp]
	push	eax
	call	_release_inode
	add	esp, 4

; 230  :     return -1;

	or	eax, -1
	jmp	SHORT $L1039
$L1052:

; 232  : 
; 233  :   if (delete_dir_entry(oldparent, oldname, oldlen) < 0)

	mov	ecx, DWORD PTR _oldlen$[ebp]
	push	ecx
	mov	edx, DWORD PTR _oldname$[ebp]
	push	edx
	mov	eax, DWORD PTR _oldparent$[ebp]
	push	eax
	call	_delete_dir_entry
	add	esp, 12					; 0000000cH
	test	eax, eax
	jge	SHORT $L1053

; 235  :     release_inode(inode);

	mov	ecx, DWORD PTR _inode$[ebp]
	push	ecx
	call	_release_inode
	add	esp, 4

; 236  :     release_inode(oldparent);

	mov	edx, DWORD PTR _oldparent$[ebp]
	push	edx
	call	_release_inode
	add	esp, 4

; 237  :     release_inode(newparent);

	mov	eax, DWORD PTR _newparent$[ebp]
	push	eax
	call	_release_inode
	add	esp, 4

; 238  :     return -1;

	or	eax, -1
	jmp	SHORT $L1039
$L1053:

; 240  : 
; 241  :   release_inode(inode);

	mov	ecx, DWORD PTR _inode$[ebp]
	push	ecx
	call	_release_inode
	add	esp, 4

; 242  :   release_inode(oldparent);

	mov	edx, DWORD PTR _oldparent$[ebp]
	push	edx
	call	_release_inode
	add	esp, 4

; 243  :   release_inode(newparent);

	mov	eax, DWORD PTR _newparent$[ebp]
	push	eax
	call	_release_inode
	add	esp, 4

; 244  :   return 0;

	xor	eax, eax
$L1039:

; 245  : }

	pop	edi
	pop	esi
	pop	ebx
	add	esp, 88					; 00000058H
	cmp	ebp, esp
	call	__chkesp
	mov	esp, ebp
	pop	ebp
	ret	0
_dfs_rename ENDP
_TEXT	ENDS
;	COMDAT _dfs_link
_TEXT	SEGMENT
_fs$ = 8
_oldname$ = 12
_newname$ = 16
_inode$ = -4
_parent$ = -8
_ino$ = -12
_len$ = -16
_dfs_link PROC NEAR					; COMDAT

; 248  : {

	push	ebp
	mov	ebp, esp
	sub	esp, 80					; 00000050H
	push	ebx
	push	esi
	push	edi
	lea	edi, DWORD PTR [ebp-80]
	mov	ecx, 20					; 00000014H
	mov	eax, -858993460				; ccccccccH
	rep stosd

; 249  :   struct inode *inode;
; 250  :   struct inode *parent;
; 251  :   ino_t ino;
; 252  :   int len;
; 253  : 
; 254  :   ino = lookup_name((struct filsys *) fs->data, DFS_INODE_ROOT, oldname, strlen(oldname));

	mov	eax, DWORD PTR _oldname$[ebp]
	push	eax
	call	_strlen
	add	esp, 4
	push	eax
	mov	ecx, DWORD PTR _oldname$[ebp]
	push	ecx
	push	0
	mov	edx, DWORD PTR _fs$[ebp]
	mov	eax, DWORD PTR [edx+272]
	push	eax
	call	_lookup_name
	add	esp, 16					; 00000010H
	mov	DWORD PTR _ino$[ebp], eax

; 255  :   if (ino == -1) return -1;

	cmp	DWORD PTR _ino$[ebp], -1
	jne	SHORT $L1066
	or	eax, -1
	jmp	$L1060
$L1066:

; 256  : 
; 257  :   inode = get_inode((struct filsys *) fs->data, ino);

	mov	ecx, DWORD PTR _ino$[ebp]
	push	ecx
	mov	edx, DWORD PTR _fs$[ebp]
	mov	eax, DWORD PTR [edx+272]
	push	eax
	call	_get_inode
	add	esp, 8
	mov	DWORD PTR _inode$[ebp], eax

; 258  :   if (!inode) return -1;

	cmp	DWORD PTR _inode$[ebp], 0
	jne	SHORT $L1068
	or	eax, -1
	jmp	$L1060
$L1068:

; 259  : 
; 260  :   len = strlen(newname);

	mov	ecx, DWORD PTR _newname$[ebp]
	push	ecx
	call	_strlen
	add	esp, 4
	mov	DWORD PTR _len$[ebp], eax

; 261  :   parent = parse_name((struct filsys *) fs->data, &newname, &len);

	lea	edx, DWORD PTR _len$[ebp]
	push	edx
	lea	eax, DWORD PTR _newname$[ebp]
	push	eax
	mov	ecx, DWORD PTR _fs$[ebp]
	mov	edx, DWORD PTR [ecx+272]
	push	edx
	call	_parse_name
	add	esp, 12					; 0000000cH
	mov	DWORD PTR _parent$[ebp], eax

; 262  :   if (!parent) 

	cmp	DWORD PTR _parent$[ebp], 0
	jne	SHORT $L1070

; 264  :     release_inode(inode);

	mov	eax, DWORD PTR _inode$[ebp]
	push	eax
	call	_release_inode
	add	esp, 4

; 265  :     return -1;

	or	eax, -1
	jmp	$L1060
$L1070:

; 267  : 
; 268  :   if (find_dir_entry(parent, newname, len) != -1)

	mov	ecx, DWORD PTR _len$[ebp]
	push	ecx
	mov	edx, DWORD PTR _newname$[ebp]
	push	edx
	mov	eax, DWORD PTR _parent$[ebp]
	push	eax
	call	_find_dir_entry
	add	esp, 12					; 0000000cH
	cmp	eax, -1
	je	SHORT $L1071

; 270  :     release_inode(inode);

	mov	ecx, DWORD PTR _inode$[ebp]
	push	ecx
	call	_release_inode
	add	esp, 4

; 271  :     release_inode(parent);

	mov	edx, DWORD PTR _parent$[ebp]
	push	edx
	call	_release_inode
	add	esp, 4

; 272  :     return -1;

	or	eax, -1
	jmp	$L1060
$L1071:

; 274  : 
; 275  :   inode->desc->linkcount++;

	mov	eax, DWORD PTR _inode$[ebp]
	mov	ecx, DWORD PTR [eax+8]
	mov	edx, DWORD PTR [ecx+16]
	add	edx, 1
	mov	eax, DWORD PTR _inode$[ebp]
	mov	ecx, DWORD PTR [eax+8]
	mov	DWORD PTR [ecx+16], edx

; 276  :   mark_inode_dirty(inode);

	mov	edx, DWORD PTR _inode$[ebp]
	push	edx
	call	_mark_inode_dirty
	add	esp, 4

; 277  : 
; 278  :   if (add_dir_entry(parent, newname, len, inode->ino) < 0)

	mov	eax, DWORD PTR _inode$[ebp]
	mov	ecx, DWORD PTR [eax+4]
	push	ecx
	mov	edx, DWORD PTR _len$[ebp]
	push	edx
	mov	eax, DWORD PTR _newname$[ebp]
	push	eax
	mov	ecx, DWORD PTR _parent$[ebp]
	push	ecx
	call	_add_dir_entry
	add	esp, 16					; 00000010H
	test	eax, eax
	jge	SHORT $L1072

; 280  :     unlink_inode(inode);

	mov	edx, DWORD PTR _inode$[ebp]
	push	edx
	call	_unlink_inode
	add	esp, 4

; 281  :     release_inode(inode);

	mov	eax, DWORD PTR _inode$[ebp]
	push	eax
	call	_release_inode
	add	esp, 4

; 282  :     release_inode(parent);

	mov	ecx, DWORD PTR _parent$[ebp]
	push	ecx
	call	_release_inode
	add	esp, 4

; 283  :     return -1;

	or	eax, -1
	jmp	SHORT $L1060
$L1072:

; 285  : 
; 286  :   release_inode(inode);

	mov	edx, DWORD PTR _inode$[ebp]
	push	edx
	call	_release_inode
	add	esp, 4

; 287  :   release_inode(parent);

	mov	eax, DWORD PTR _parent$[ebp]
	push	eax
	call	_release_inode
	add	esp, 4

; 288  :   return 0;

	xor	eax, eax
$L1060:

; 289  : }

	pop	edi
	pop	esi
	pop	ebx
	add	esp, 80					; 00000050H
	cmp	ebp, esp
	call	__chkesp
	mov	esp, ebp
	pop	ebp
	ret	0
_dfs_link ENDP
_TEXT	ENDS
;	COMDAT _dfs_unlink
_TEXT	SEGMENT
_fs$ = 8
_name$ = 12
_dir$ = -4
_inode$ = -8
_ino$ = -12
_len$ = -16
_dfs_unlink PROC NEAR					; COMDAT

; 292  : {

	push	ebp
	mov	ebp, esp
	sub	esp, 80					; 00000050H
	push	ebx
	push	esi
	push	edi
	lea	edi, DWORD PTR [ebp-80]
	mov	ecx, 20					; 00000014H
	mov	eax, -858993460				; ccccccccH
	rep stosd

; 293  :   struct inode *dir;
; 294  :   struct inode *inode;
; 295  :   ino_t ino;
; 296  :   int len;
; 297  : 
; 298  :   len = strlen(name);

	mov	eax, DWORD PTR _name$[ebp]
	push	eax
	call	_strlen
	add	esp, 4
	mov	DWORD PTR _len$[ebp], eax

; 299  :   dir = parse_name((struct filsys *) fs->data, &name, &len);

	lea	ecx, DWORD PTR _len$[ebp]
	push	ecx
	lea	edx, DWORD PTR _name$[ebp]
	push	edx
	mov	eax, DWORD PTR _fs$[ebp]
	mov	ecx, DWORD PTR [eax+272]
	push	ecx
	call	_parse_name
	add	esp, 12					; 0000000cH
	mov	DWORD PTR _dir$[ebp], eax

; 300  :   if (!dir) return -1;

	cmp	DWORD PTR _dir$[ebp], 0
	jne	SHORT $L1083
	or	eax, -1
	jmp	$L1077
$L1083:

; 301  : 
; 302  :   ino = find_dir_entry(dir, name, len);

	mov	edx, DWORD PTR _len$[ebp]
	push	edx
	mov	eax, DWORD PTR _name$[ebp]
	push	eax
	mov	ecx, DWORD PTR _dir$[ebp]
	push	ecx
	call	_find_dir_entry
	add	esp, 12					; 0000000cH
	mov	DWORD PTR _ino$[ebp], eax

; 303  :   if (ino == -1)

	cmp	DWORD PTR _ino$[ebp], -1
	jne	SHORT $L1084

; 305  :     release_inode(dir);

	mov	edx, DWORD PTR _dir$[ebp]
	push	edx
	call	_release_inode
	add	esp, 4

; 306  :     return -1;

	or	eax, -1
	jmp	$L1077
$L1084:

; 308  : 
; 309  :   inode = get_inode(dir->fs, ino);

	mov	eax, DWORD PTR _ino$[ebp]
	push	eax
	mov	ecx, DWORD PTR _dir$[ebp]
	mov	edx, DWORD PTR [ecx]
	push	edx
	call	_get_inode
	add	esp, 8
	mov	DWORD PTR _inode$[ebp], eax

; 310  :   if (!dir)

	cmp	DWORD PTR _dir$[ebp], 0
	jne	SHORT $L1085

; 312  :     release_inode(dir);

	mov	eax, DWORD PTR _dir$[ebp]
	push	eax
	call	_release_inode
	add	esp, 4

; 313  :     return -1;

	or	eax, -1
	jmp	$L1077
$L1085:

; 315  : 
; 316  :   if (inode->desc->flags & DFS_INODE_FLAG_DIRECTORY)

	mov	ecx, DWORD PTR _inode$[ebp]
	mov	edx, DWORD PTR [ecx+8]
	mov	eax, DWORD PTR [edx]
	and	eax, 1
	test	eax, eax
	je	SHORT $L1086

; 318  :     release_inode(inode);

	mov	ecx, DWORD PTR _inode$[ebp]
	push	ecx
	call	_release_inode
	add	esp, 4

; 319  :     release_inode(dir);

	mov	edx, DWORD PTR _dir$[ebp]
	push	edx
	call	_release_inode
	add	esp, 4

; 320  :     return -1;

	or	eax, -1
	jmp	SHORT $L1077
$L1086:

; 322  : 
; 323  :   if (delete_dir_entry(dir, name, len) < 0)

	mov	eax, DWORD PTR _len$[ebp]
	push	eax
	mov	ecx, DWORD PTR _name$[ebp]
	push	ecx
	mov	edx, DWORD PTR _dir$[ebp]
	push	edx
	call	_delete_dir_entry
	add	esp, 12					; 0000000cH
	test	eax, eax
	jge	SHORT $L1087

; 325  :     release_inode(inode);

	mov	eax, DWORD PTR _inode$[ebp]
	push	eax
	call	_release_inode
	add	esp, 4

; 326  :     release_inode(dir);

	mov	ecx, DWORD PTR _dir$[ebp]
	push	ecx
	call	_release_inode
	add	esp, 4

; 327  :     return -1;

	or	eax, -1
	jmp	SHORT $L1077
$L1087:

; 329  : 
; 330  :   if (unlink_inode(inode) < 0)

	mov	edx, DWORD PTR _inode$[ebp]
	push	edx
	call	_unlink_inode
	add	esp, 4
	test	eax, eax
	jge	SHORT $L1088

; 332  :     release_inode(inode);

	mov	eax, DWORD PTR _inode$[ebp]
	push	eax
	call	_release_inode
	add	esp, 4

; 333  :     release_inode(dir);

	mov	ecx, DWORD PTR _dir$[ebp]
	push	ecx
	call	_release_inode
	add	esp, 4

; 334  :     return -1;

	or	eax, -1
	jmp	SHORT $L1077
$L1088:

; 336  : 
; 337  :   release_inode(inode);

	mov	edx, DWORD PTR _inode$[ebp]
	push	edx
	call	_release_inode
	add	esp, 4

; 338  :   release_inode(dir);

	mov	eax, DWORD PTR _dir$[ebp]
	push	eax
	call	_release_inode
	add	esp, 4

; 339  :   return 0;

	xor	eax, eax
$L1077:

; 340  : }

	pop	edi
	pop	esi
	pop	ebx
	add	esp, 80					; 00000050H
	cmp	ebp, esp
	call	__chkesp
	mov	esp, ebp
	pop	ebp
	ret	0
_dfs_unlink ENDP
_TEXT	ENDS
END
