	TITLE	C:\src\dfs\dfs.c
	.386P
include listing.inc
if @Version gt 510
.model FLAT
else
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
_DATA	SEGMENT DWORD USE32 PUBLIC 'DATA'
_DATA	ENDS
CONST	SEGMENT DWORD USE32 PUBLIC 'CONST'
CONST	ENDS
_BSS	SEGMENT DWORD USE32 PUBLIC 'BSS'
_BSS	ENDS
_TLS	SEGMENT DWORD USE32 PUBLIC 'TLS'
_TLS	ENDS
;	COMDAT ??_C@_0BG@OJEE@filesystem?5too?5smalll?$AA@
_DATA	SEGMENT DWORD USE32 PUBLIC 'DATA'
_DATA	ENDS
;	COMDAT ??_C@_0BK@EJND@unable?5to?5read?5superblock?$AA@
_DATA	SEGMENT DWORD USE32 PUBLIC 'DATA'
_DATA	ENDS
;	COMDAT ??_C@_0BG@GHCG@invalid?5DFS?5signature?$AA@
_DATA	SEGMENT DWORD USE32 PUBLIC 'DATA'
_DATA	ENDS
;	COMDAT ??_C@_0BE@CEGG@invalid?5DFS?5version?$AA@
_DATA	SEGMENT DWORD USE32 PUBLIC 'DATA'
_DATA	ENDS
;	COMDAT _set_bit
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
;	COMDAT _test_bit
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
;	COMDAT _set_bits
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
;	COMDAT _mark_group_desc_dirty
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
;	COMDAT _create_filesystem
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
;	COMDAT _open_filesystem
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
;	COMDAT _close_filesystem
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
;	COMDAT _new_block
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
FLAT	GROUP _DATA, CONST, _BSS
	ASSUME	CS: FLAT, DS: FLAT, SS: FLAT
endif
PUBLIC	_mark_group_desc_dirty
EXTRN	_mark_buffer_updated:NEAR
;	COMDAT _mark_group_desc_dirty
_TEXT	SEGMENT
_fs$ = 8
_group$ = 12
_mark_group_desc_dirty PROC NEAR			; COMDAT

; 26   :   mark_buffer_updated(fs->groupdesc_buffers[group / fs->groupdescs_per_block]);

	mov	ecx, DWORD PTR _fs$[esp-4]
	mov	eax, DWORD PTR _group$[esp-4]
	xor	edx, edx
	div	DWORD PTR [ecx+16]
	mov	ecx, DWORD PTR [ecx+28]
	mov	edx, DWORD PTR [ecx+eax*4]
	push	edx
	call	_mark_buffer_updated
	pop	ecx

; 27   : }

	ret	0
_mark_group_desc_dirty ENDP
_TEXT	ENDS
PUBLIC	_create_filesystem
PUBLIC	??_C@_0BG@OJEE@filesystem?5too?5smalll?$AA@	; `string'
EXTRN	_malloc:NEAR
EXTRN	_init_buffer_pool:NEAR
EXTRN	_alloc_buffer:NEAR
EXTRN	_release_buffer:NEAR
EXTRN	_panic:NEAR
EXTRN	_dev_getsize:NEAR
;	COMDAT ??_C@_0BG@OJEE@filesystem?5too?5smalll?$AA@
; File C:\src\dfs\bitops.h
_DATA	SEGMENT
??_C@_0BG@OJEE@filesystem?5too?5smalll?$AA@ DB 'filesystem too smalll', 00H ; `string'
_DATA	ENDS
;	COMDAT _create_filesystem
_TEXT	SEGMENT
_devno$ = 8
_buf$ = -12
$T69536 = -4
$T69537 = -8
_create_filesystem PROC NEAR				; COMDAT

; 30   : {

	sub	esp, 12					; 0000000cH
	push	ebx
	push	ebp
	push	esi
	push	edi

; 31   :   struct filsys *fs;
; 32   :   unsigned int blocks;
; 33   :   unsigned int first_block;
; 34   :   struct groupdesc *gd;
; 35   :   struct buf *buf;
; 36   :   unsigned int i;
; 37   : 
; 38   :   // Allocate file system
; 39   :   fs = (struct filsys *) malloc(sizeof(struct filsys));

	push	36					; 00000024H
	call	_malloc
	mov	esi, eax

; 40   :   memset(fs, 0, sizeof(struct filsys));

	mov	ecx, 9
	xor	eax, eax
	mov	edi, esi
	rep stosd

; 41   : 
; 42   :   // Allocate super block
; 43   :   fs->super = (struct superblock *) malloc(SECTORSIZE);

	push	512					; 00000200H
	call	_malloc
	mov	edi, eax

; 44   :   memset(fs->super, 0, SECTORSIZE);

	mov	ecx, 128				; 00000080H
	xor	eax, eax
	mov	DWORD PTR [esi+20], edi
	rep stosd

; 45   : 
; 46   :   // Set device number and block size
; 47   :   fs->devno = devno;

	mov	eax, DWORD PTR _devno$[esp+32]

; 48   :   fs->blocksize = BLOCKSIZE;
; 49   : 
; 50   :   // Initialize buffer cache
; 51   :   fs->cache = init_buffer_pool(devno, CACHEBUFFERS, fs->blocksize);

	push	4096					; 00001000H
	push	1024					; 00000400H
	push	eax
	mov	DWORD PTR [esi], eax
	mov	DWORD PTR [esi+4], 4096			; 00001000H
	call	_init_buffer_pool
	mov	DWORD PTR [esi+24], eax

; 52   : 
; 53   :   // Set signature, version and block size in super block
; 54   :   fs->super->signature = DFS_SIGNATURE;

	mov	eax, DWORD PTR [esi+20]

; 55   :   fs->super->version = DFS_VERSION;

	mov	ebx, 1
	add	esp, 20					; 00000014H
	mov	DWORD PTR [eax], 5457476		; 00534644H
	mov	ecx, DWORD PTR [esi+20]
	mov	DWORD PTR [ecx+4], ebx

; 56   :   fs->super->log_block_size = LOGBLOCKSIZE;

	mov	edx, DWORD PTR [esi+20]
	mov	DWORD PTR [edx+8], 12			; 0000000cH

; 57   : 
; 58   :   // Each group has as many blocks as can be represented by the block bitmap block
; 59   :   fs->super->blocks_per_group = fs->blocksize * BITS_PER_BYTE;

	mov	eax, DWORD PTR [esi+4]
	mov	ecx, DWORD PTR [esi+20]
	shl	eax, 3
	mov	DWORD PTR [ecx+40], eax

; 60   : 
; 61   :   // The number of inodes in a group is computed as a ratio of the size of group
; 62   :   fs->super->inodes_per_group = fs->blocksize * fs->super->blocks_per_group / INODE_RATIO;

	mov	eax, DWORD PTR [esi+20]
	mov	edx, DWORD PTR [eax+40]
	imul	edx, DWORD PTR [esi+4]
	shr	edx, 12					; 0000000cH
	mov	DWORD PTR [eax+44], edx

; 63   :   if (fs->super->inodes_per_group > fs->blocksize * BITS_PER_BYTE) fs->super->inodes_per_group = fs->blocksize * BITS_PER_BYTE;

	mov	ecx, DWORD PTR [esi+20]
	mov	eax, DWORD PTR [esi+4]
	mov	edx, DWORD PTR [ecx+44]
	shl	eax, 3
	cmp	edx, eax
	jbe	SHORT $L69426
	mov	DWORD PTR [ecx+44], eax
$L69426:

; 64   :   fs->inode_blocks_per_group = (fs->super->inodes_per_group * sizeof(struct inode) + fs->blocksize - 1) / fs->blocksize;

	mov	eax, DWORD PTR [esi+20]
	mov	ecx, DWORD PTR [esi+4]
	mov	eax, DWORD PTR [eax+44]
	mov	edx, eax
	shl	edx, 4
	add	edx, eax
	lea	eax, DWORD PTR [ecx+edx*8-1]
	xor	edx, edx
	div	ecx
	mov	DWORD PTR [esi+12], eax

; 65   : 
; 66   :   // Get the device size in sectors from the device and convert it to blocks
; 67   :   fs->super->block_count = dev_getsize(fs->devno) / (fs->blocksize / SECTORSIZE);

	mov	eax, DWORD PTR [esi]
	push	eax
	call	_dev_getsize
	mov	ecx, DWORD PTR [esi+4]
	xor	edx, edx
	shr	ecx, 9
	div	ecx
	mov	edx, DWORD PTR [esi+20]
	add	esp, 4
	mov	DWORD PTR [edx+28], eax

; 68   : 
; 69   :   // Calculate the number of group descriptors and the number of blocks to store them
; 70   :   fs->super->group_count = (fs->super->block_count + fs->super->blocks_per_group - 1) / fs->super->blocks_per_group;

	mov	ecx, DWORD PTR [esi+20]
	xor	edx, edx
	mov	edi, DWORD PTR [ecx+40]
	mov	eax, DWORD PTR [ecx+28]
	lea	eax, DWORD PTR [eax+edi-1]
	div	edi
	mov	DWORD PTR [ecx+20], eax

; 71   :   fs->groupdescs_per_block = fs->blocksize / sizeof(struct groupdesc);

	mov	ecx, DWORD PTR [esi+4]

; 72   :   fs->groupdesc_blocks = (fs->super->group_count * sizeof(struct groupdesc) + fs->blocksize - 1) / fs->blocksize;

	mov	edi, DWORD PTR [esi+20]
	mov	edx, ecx
	shr	edx, 5
	mov	DWORD PTR [esi+16], edx
	mov	eax, DWORD PTR [edi+20]
	shl	eax, 5
	xor	edx, edx
	lea	eax, DWORD PTR [eax+ecx-1]
	div	ecx
	mov	DWORD PTR [esi+8], eax

; 73   : 
; 74   :   // The group descriptor table starts in block 1 (or block 2 of blocksize is 512)
; 75   :   fs->super->groupdesc_table_block = 1;

	mov	DWORD PTR [edi+12], ebx

; 76   :   if (fs->blocksize <= SECTORSIZE) fs->super->groupdesc_table_block = 2;

	cmp	DWORD PTR [esi+4], 512			; 00000200H
	ja	SHORT $L69430
	mov	ecx, DWORD PTR [esi+20]
	mov	DWORD PTR [ecx+12], 2
$L69430:

; 77   : 
; 78   :   // If the last group is too small to hold the bitmaps and inode table skip it
; 79   :   blocks =  fs->super->block_count % fs->super->blocks_per_group;

	mov	ecx, DWORD PTR [esi+20]
	xor	edx, edx
	mov	eax, DWORD PTR [ecx+28]
	div	DWORD PTR [ecx+40]

; 80   :   if (blocks > 0 && blocks < fs->inode_blocks_per_group + 2) fs->super->group_count--;

	test	edx, edx
	jbe	SHORT $L69431
	mov	eax, DWORD PTR [esi+12]
	add	eax, 2
	cmp	edx, eax
	jae	SHORT $L69431
	dec	DWORD PTR [ecx+20]
$L69431:

; 81   :   if (fs->super->group_count == 0) panic("filesystem too smalll");

	mov	ecx, DWORD PTR [esi+20]
	mov	eax, DWORD PTR [ecx+20]
	test	eax, eax
	jne	SHORT $L69432
	push	OFFSET FLAT:??_C@_0BG@OJEE@filesystem?5too?5smalll?$AA@ ; `string'
	call	_panic
	add	esp, 4
$L69432:

; 82   : 
; 83   :   // Allocate group descriptors
; 84   :   fs->groupdesc_buffers = (struct buf **) malloc(sizeof(struct buf *) * fs->groupdesc_blocks);

	mov	edx, DWORD PTR [esi+8]
	shl	edx, 2
	push	edx
	call	_malloc
	mov	DWORD PTR [esi+28], eax

; 85   :   fs->groups = (struct group *) malloc(sizeof(struct group) * fs->super->group_count);

	mov	eax, DWORD PTR [esi+20]
	mov	eax, DWORD PTR [eax+20]
	lea	ecx, DWORD PTR [eax+eax*2]
	shl	ecx, 2
	push	ecx
	call	_malloc
	mov	DWORD PTR [esi+32], eax

; 86   : 
; 87   :   for (i = 0; i < fs->groupdesc_blocks; i++)

	mov	eax, DWORD PTR [esi+8]
	add	esp, 8
	xor	edi, edi
	test	eax, eax
	jbe	SHORT $L69440
$L69438:

; 88   :   {
; 89   :     fs->groupdesc_buffers[i] = alloc_buffer(fs->cache, fs->super->groupdesc_table_block + i);

	mov	edx, DWORD PTR [esi+20]
	mov	ecx, DWORD PTR [esi+24]
	mov	eax, DWORD PTR [edx+12]
	add	eax, edi
	push	eax
	push	ecx
	call	_alloc_buffer
	mov	edx, DWORD PTR [esi+28]
	add	esp, 8
	mov	DWORD PTR [edx+edi*4], eax
	mov	eax, DWORD PTR [esi+8]
	inc	edi
	cmp	edi, eax
	jb	SHORT $L69438
$L69440:

; 90   :   }
; 91   : 
; 92   :   for (i = 0; i < fs->super->group_count; i++)

	mov	eax, DWORD PTR [esi+20]
	xor	ecx, ecx
	mov	edx, DWORD PTR [eax+20]
	test	edx, edx
	jbe	SHORT $L69443
	xor	ebx, ebx
$L69441:

; 93   :   {
; 94   :     gd = (struct groupdesc *) fs->groupdesc_buffers[i / fs->groupdescs_per_block]->data;

	mov	edi, DWORD PTR [esi+16]
	mov	eax, ecx
	xor	edx, edx
	add	ebx, 12					; 0000000cH
	div	edi

; 95   :     gd += (i % fs->groupdescs_per_block);

	mov	edx, DWORD PTR [esi+28]
	mov	ebp, DWORD PTR [edx+eax*4]
	mov	eax, ecx
	xor	edx, edx
	div	edi
	mov	eax, DWORD PTR [ebp+28]
	shl	edx, 5
	add	eax, edx

; 96   : 
; 97   :     fs->groups[i].desc = gd;

	mov	edx, DWORD PTR [esi+32]
	mov	DWORD PTR [ebx+edx-12], eax

; 98   :     fs->groups[i].first_free_block = 0;

	mov	edx, DWORD PTR [esi+32]
	xor	eax, eax
	inc	ecx
	mov	DWORD PTR [ebx+edx-8], eax

; 99   :     fs->groups[i].first_free_inode = 0;

	mov	edx, DWORD PTR [esi+32]
	mov	DWORD PTR [ebx+edx-4], eax
	mov	eax, DWORD PTR [esi+20]
	cmp	ecx, DWORD PTR [eax+20]
	jb	SHORT $L69441

; 90   :   }
; 91   : 
; 92   :   for (i = 0; i < fs->super->group_count; i++)

	mov	ebx, 1
$L69443:

; 100  :   }
; 101  : 
; 102  :   // Reserve inode for root directory
; 103  :   fs->super->reserved_inodes = 1;

	mov	ecx, DWORD PTR [esi+20]
	mov	DWORD PTR [ecx+16], ebx

; 104  : 
; 105  :   // Set inode count based on group count
; 106  :   fs->super->inode_count = fs->inode_blocks_per_group * fs->super->group_count;

	mov	eax, DWORD PTR [esi+20]

; 107  : 
; 108  :   // All blocks and inodes initially free
; 109  :   fs->super->free_inode_count = fs->super->inode_count;
; 110  :   fs->super->free_block_count = fs->super->block_count;
; 111  : 
; 112  :   // Initialize block bitmaps
; 113  :   for (i = 0; i < fs->super->group_count; i++)

	xor	ebx, ebx
	mov	edx, DWORD PTR [eax+20]
	imul	edx, DWORD PTR [esi+12]
	mov	DWORD PTR [eax+24], edx
	mov	eax, DWORD PTR [esi+20]
	mov	ecx, DWORD PTR [eax+24]
	mov	DWORD PTR [eax+32], ecx
	mov	eax, DWORD PTR [esi+20]
	mov	edx, DWORD PTR [eax+28]
	mov	DWORD PTR [eax+36], edx
	mov	ecx, DWORD PTR [esi+20]
	mov	eax, DWORD PTR [ecx+20]
	test	eax, eax
	jbe	$L69547
$L69445:

; 114  :   {
; 115  :     gd = fs->groups[i].desc;

	mov	edx, DWORD PTR [esi+32]
	lea	eax, DWORD PTR [ebx+ebx*2]

; 116  :     blocks = 0;

	xor	edi, edi
	mov	ebp, DWORD PTR [edx+eax*4]

; 117  :     first_block = fs->super->blocks_per_group * i;

	mov	eax, DWORD PTR [ecx+40]
	imul	eax, ebx

; 118  : 
; 119  :     // The first group needs blocks for the super block and the group descriptors
; 120  :     if (i == 0) blocks = fs->super->groupdesc_table_block + fs->groupdesc_blocks;

	test	ebx, ebx
	jne	SHORT $L69448
	mov	edi, DWORD PTR [ecx+12]
	mov	ecx, DWORD PTR [esi+8]
	add	edi, ecx
$L69448:

; 121  : 
; 122  :     // Next blocks in group are the block bitmap, inode bitmap and the inode table
; 123  :     gd->block_bitmap_block = first_block + blocks++;

	lea	ecx, DWORD PTR [eax+edi]
	inc	edi
	mov	DWORD PTR [ebp+4], ecx

; 124  :     gd->inode_bitmap_block = first_block + blocks++;

	lea	edx, DWORD PTR [eax+edi]
	inc	edi

; 125  :     gd->inode_table_block = first_block + blocks;

	add	eax, edi
	mov	DWORD PTR [ebp+8], edx
	mov	DWORD PTR [ebp+12], eax

; 126  :     blocks += fs->inode_blocks_per_group;

	mov	edx, DWORD PTR [esi+12]

; 127  : 
; 128  :     // Update block bitmap
; 129  :     buf = alloc_buffer(fs->cache, gd->block_bitmap_block);

	mov	eax, ecx
	mov	ecx, DWORD PTR [esi+24]
	push	eax
	push	ecx
	add	edi, edx
	call	_alloc_buffer

; 130  :     set_bits(buf->data, 0, blocks);

	mov	ecx, DWORD PTR [eax+28]
	add	esp, 8
	xor	edx, edx
	mov	DWORD PTR _buf$[esp+28], eax
	test	edi, edi
	mov	DWORD PTR $T69536[esp+28], ecx
	jle	SHORT $L69532
	lea	eax, DWORD PTR [edi]
	mov	DWORD PTR 8+[esp+24], eax
	jmp	SHORT $L69531
$L69549:

; 121  : 
; 122  :     // Next blocks in group are the block bitmap, inode bitmap and the inode table
; 123  :     gd->block_bitmap_block = first_block + blocks++;

	mov	edx, DWORD PTR $T69537[esp+28]

; 130  :     set_bits(buf->data, 0, blocks);

$L69531:
	mov	ecx, edx
	inc	edx
	mov	eax, ecx
	mov	DWORD PTR $T69537[esp+28], edx
	cdq
	and	edx, 7
	add	eax, edx
	mov	edx, DWORD PTR $T69536[esp+28]
	sar	eax, 3
	add	eax, edx
	and	ecx, -2147483641			; 80000007H
	jns	SHORT $L69550
	dec	ecx
	or	ecx, -8					; fffffff8H
	inc	ecx
$L69550:
	mov	dl, 1
	shl	dl, cl
	mov	cl, BYTE PTR [eax]
	or	cl, dl
	mov	BYTE PTR [eax], cl
	mov	eax, DWORD PTR 8+[esp+24]
	dec	eax
	mov	DWORD PTR 8+[esp+24], eax
	jne	SHORT $L69549
	mov	eax, DWORD PTR _buf$[esp+28]
$L69532:

; 131  :     mark_buffer_updated(buf);

	push	eax
	call	_mark_buffer_updated

; 132  :     release_buffer(fs->cache, buf);

	mov	eax, DWORD PTR _buf$[esp+32]
	mov	ecx, DWORD PTR [esi+24]
	push	eax
	push	ecx
	call	_release_buffer

; 133  : 
; 134  :     // Determine the block count for the group. The last group may be truncated
; 135  :     if (fs->super->blocks_per_group * (i + 1) < fs->super->block_count)

	mov	ecx, DWORD PTR [esi+20]
	lea	edx, DWORD PTR [ebx+1]
	mov	DWORD PTR 8+[esp+36], edx
	add	esp, 12					; 0000000cH
	mov	eax, DWORD PTR [ecx+40]
	mov	ecx, DWORD PTR [ecx+28]
	imul	edx, eax
	cmp	edx, ecx
	jae	SHORT $L69449

; 136  :       gd->block_count = fs->super->block_count - fs->super->blocks_per_group * i;

	imul	eax, ebx
	sub	ecx, eax
	mov	DWORD PTR [ebp], ecx

; 137  :     else

	jmp	SHORT $L69450
$L69449:

; 138  :       gd->block_count = fs->super->blocks_per_group;

	mov	DWORD PTR [ebp], eax
$L69450:

; 139  : 
; 140  :     // Set the count of free blocks and inodes for group
; 141  :     gd->free_inode_count = fs->super->inodes_per_group;

	mov	edx, DWORD PTR [esi+20]

; 142  :     gd->free_block_count = gd->block_count - blocks;

	mov	ecx, DWORD PTR [ebp]
	sub	ecx, edi

; 143  : 
; 144  :     mark_group_desc_dirty(fs, i);

	push	ebx
	mov	eax, DWORD PTR [edx+44]
	push	esi
	mov	DWORD PTR [ebp+20], eax
	mov	DWORD PTR [ebp+16], ecx
	call	_mark_group_desc_dirty
	mov	ecx, DWORD PTR [esi+20]
	mov	ebx, DWORD PTR 8+[esp+32]
	add	esp, 8
	cmp	ebx, DWORD PTR [ecx+20]
	jb	$L69445
$L69547:

; 145  :   }
; 146  : 
; 147  :   return fs;

	mov	eax, esi
	pop	edi
	pop	esi
	pop	ebp
	pop	ebx

; 148  : }

	add	esp, 12					; 0000000cH
	ret	0
_create_filesystem ENDP
_TEXT	ENDS
PUBLIC	_open_filesystem
PUBLIC	??_C@_0BK@EJND@unable?5to?5read?5superblock?$AA@ ; `string'
PUBLIC	??_C@_0BG@GHCG@invalid?5DFS?5signature?$AA@	; `string'
PUBLIC	??_C@_0BE@CEGG@invalid?5DFS?5version?$AA@	; `string'
EXTRN	_get_buffer:NEAR
EXTRN	_dev_read:NEAR
;	COMDAT ??_C@_0BK@EJND@unable?5to?5read?5superblock?$AA@
; File C:\src\dfs\dfs.c
_DATA	SEGMENT
??_C@_0BK@EJND@unable?5to?5read?5superblock?$AA@ DB 'unable to read super'
	DB	'block', 00H					; `string'
_DATA	ENDS
;	COMDAT ??_C@_0BG@GHCG@invalid?5DFS?5signature?$AA@
_DATA	SEGMENT
??_C@_0BG@GHCG@invalid?5DFS?5signature?$AA@ DB 'invalid DFS signature', 00H ; `string'
_DATA	ENDS
;	COMDAT ??_C@_0BE@CEGG@invalid?5DFS?5version?$AA@
_DATA	SEGMENT
??_C@_0BE@CEGG@invalid?5DFS?5version?$AA@ DB 'invalid DFS version', 00H ; `string'
_DATA	ENDS
;	COMDAT _open_filesystem
_TEXT	SEGMENT
_devno$ = 8
_open_filesystem PROC NEAR				; COMDAT

; 151  : {

	push	esi
	push	edi

; 152  :   struct filsys *fs;
; 153  :   struct groupdesc *gd;
; 154  :   unsigned int i;
; 155  : 
; 156  :   // Allocate file system
; 157  :   fs = (struct filsys *) malloc(sizeof(struct filsys));

	push	36					; 00000024H
	call	_malloc
	mov	esi, eax

; 158  :   memset(fs, 0, sizeof(struct filsys));

	mov	ecx, 9
	xor	eax, eax
	mov	edi, esi
	rep stosd

; 159  : 
; 160  :   // Allocate and read super block
; 161  :   fs->super = (struct superblock *) malloc(SECTORSIZE);

	push	512					; 00000200H
	call	_malloc
	mov	edi, eax

; 162  :   memset(fs->super, 0, SECTORSIZE);

	mov	ecx, 128				; 00000080H
	xor	eax, eax
	mov	DWORD PTR [esi+20], edi
	rep stosd

; 163  :   if (dev_read(devno, fs->super, SECTORSIZE, 1) != SECTORSIZE) panic("unable to read superblock");

	mov	eax, DWORD PTR [esi+20]
	mov	edi, DWORD PTR _devno$[esp+12]
	push	1
	push	512					; 00000200H
	push	eax
	push	edi
	call	_dev_read
	add	esp, 24					; 00000018H
	cmp	eax, 512				; 00000200H
	je	SHORT $L69461
	push	OFFSET FLAT:??_C@_0BK@EJND@unable?5to?5read?5superblock?$AA@ ; `string'
	call	_panic
	add	esp, 4
$L69461:

; 164  : 
; 165  :   // Check signature and version
; 166  :   if (fs->super->signature != DFS_SIGNATURE) panic("invalid DFS signature");

	mov	ecx, DWORD PTR [esi+20]
	cmp	DWORD PTR [ecx], 5457476		; 00534644H
	je	SHORT $L69463
	push	OFFSET FLAT:??_C@_0BG@GHCG@invalid?5DFS?5signature?$AA@ ; `string'
	call	_panic
	add	esp, 4
$L69463:

; 167  :   if (fs->super->version != DFS_VERSION) panic("invalid DFS version");

	mov	edx, DWORD PTR [esi+20]
	cmp	DWORD PTR [edx+4], 1
	je	SHORT $L69465
	push	OFFSET FLAT:??_C@_0BE@CEGG@invalid?5DFS?5version?$AA@ ; `string'
	call	_panic
	add	esp, 4
$L69465:

; 168  : 
; 169  :   // Set device number and block size
; 170  :   fs->devno = devno;
; 171  :   fs->blocksize = 1 << fs->super->log_block_size;

	mov	ecx, DWORD PTR [esi+20]
	mov	DWORD PTR [esi], edi
	mov	eax, 1
	mov	ecx, DWORD PTR [ecx+8]
	shl	eax, cl

; 172  : 
; 173  :   // Initialize buffer cache
; 174  :   fs->cache = init_buffer_pool(devno, CACHEBUFFERS, fs->blocksize);

	push	eax
	push	1024					; 00000400H
	push	edi
	mov	DWORD PTR [esi+4], eax
	call	_init_buffer_pool

; 175  : 
; 176  :   // Calculate the number of group descriptors blocks
; 177  :   fs->groupdescs_per_block = fs->blocksize / sizeof(struct groupdesc);

	mov	edx, DWORD PTR [esi+4]

; 178  :   fs->groupdesc_blocks = (fs->super->group_count * sizeof(struct groupdesc) + fs->blocksize - 1) / fs->blocksize;

	mov	ecx, DWORD PTR [esi+4]
	mov	DWORD PTR [esi+24], eax
	mov	eax, DWORD PTR [esi+20]
	shr	edx, 5
	mov	DWORD PTR [esi+16], edx
	mov	edx, DWORD PTR [eax+20]
	shl	edx, 5
	lea	eax, DWORD PTR [edx+ecx-1]
	xor	edx, edx
	div	ecx
	mov	DWORD PTR [esi+8], eax

; 179  : 
; 180  :   // Read group descriptors
; 181  :   fs->groupdesc_buffers = (struct buf **) malloc(sizeof(struct buf *) * fs->groupdesc_blocks);

	shl	eax, 2
	push	eax
	call	_malloc

; 182  :   fs->groups = (struct group *) malloc(sizeof(struct group) * fs->super->group_count);

	mov	ecx, DWORD PTR [esi+20]
	mov	DWORD PTR [esi+28], eax
	mov	eax, DWORD PTR [ecx+20]
	lea	edx, DWORD PTR [eax+eax*2]
	shl	edx, 2
	push	edx
	call	_malloc
	mov	DWORD PTR [esi+32], eax

; 183  :   for (i = 0; i < fs->groupdesc_blocks; i++)

	mov	eax, DWORD PTR [esi+8]
	add	esp, 20					; 00000014H
	xor	edi, edi
	test	eax, eax
	jbe	SHORT $L69475
$L69473:

; 184  :   {
; 185  :     fs->groupdesc_buffers[i] = get_buffer(fs->cache, fs->super->groupdesc_table_block + i);

	mov	eax, DWORD PTR [esi+20]
	mov	edx, DWORD PTR [esi+24]
	mov	ecx, DWORD PTR [eax+12]
	add	ecx, edi
	push	ecx
	push	edx
	call	_get_buffer
	mov	ecx, DWORD PTR [esi+28]
	add	esp, 8
	mov	DWORD PTR [ecx+edi*4], eax
	mov	eax, DWORD PTR [esi+8]
	inc	edi
	cmp	edi, eax
	jb	SHORT $L69473
$L69475:

; 186  :   }
; 187  : 
; 188  :   for (i = 0; i < fs->super->group_count; i++)

	mov	edx, DWORD PTR [esi+20]
	xor	ecx, ecx
	mov	eax, DWORD PTR [edx+20]
	test	eax, eax
	jbe	SHORT $L69557
	push	ebx
	push	ebp
	xor	edi, edi
$L69476:

; 189  :   {
; 190  :     gd = (struct groupdesc *) fs->groupdesc_buffers[i / fs->groupdescs_per_block]->data;

	mov	ebx, DWORD PTR [esi+16]
	mov	eax, ecx
	xor	edx, edx
	add	edi, 12					; 0000000cH
	div	ebx

; 191  :     gd += (i % fs->groupdescs_per_block);

	mov	edx, DWORD PTR [esi+28]
	mov	ebp, DWORD PTR [edx+eax*4]
	mov	eax, ecx
	xor	edx, edx
	div	ebx
	mov	eax, DWORD PTR [ebp+28]
	shl	edx, 5
	add	eax, edx

; 192  : 
; 193  :     fs->groups[i].desc = gd;

	mov	edx, DWORD PTR [esi+32]
	mov	DWORD PTR [edx+edi-12], eax

; 194  :     fs->groups[i].first_free_block = 0;

	mov	edx, DWORD PTR [esi+32]
	xor	eax, eax
	inc	ecx
	mov	DWORD PTR [edx+edi-8], eax

; 195  :     fs->groups[i].first_free_inode = 0;

	mov	edx, DWORD PTR [esi+32]
	mov	DWORD PTR [edx+edi-4], eax
	mov	eax, DWORD PTR [esi+20]
	cmp	ecx, DWORD PTR [eax+20]
	jb	SHORT $L69476
	pop	ebp
	pop	ebx

; 196  :   }
; 197  : 
; 198  :   return fs;

	mov	eax, esi
	pop	edi
	pop	esi

; 199  : }

	ret	0
$L69557:

; 196  :   }
; 197  : 
; 198  :   return fs;

	mov	eax, esi
	pop	edi
	pop	esi

; 199  : }

	ret	0
_open_filesystem ENDP
_TEXT	ENDS
PUBLIC	_close_filesystem
EXTRN	_free:NEAR
EXTRN	_free_buffer_pool:NEAR
EXTRN	_flush_buffers:NEAR
EXTRN	_dev_write:NEAR
;	COMDAT _close_filesystem
_TEXT	SEGMENT
_fs$ = 8
_close_filesystem PROC NEAR				; COMDAT

; 202  : {

	push	esi

; 203  :   unsigned int i;
; 204  : 
; 205  :   // Release all group descriptors
; 206  :   for (i = 0; i < fs->groupdesc_blocks; i++) release_buffer(fs->cache, fs->groupdesc_buffers[i]);

	mov	esi, DWORD PTR _fs$[esp]
	push	edi
	xor	edi, edi
	mov	eax, DWORD PTR [esi+8]
	test	eax, eax
	jbe	SHORT $L69486
$L69484:
	mov	eax, DWORD PTR [esi+28]
	mov	edx, DWORD PTR [esi+24]
	mov	ecx, DWORD PTR [eax+edi*4]
	push	ecx
	push	edx
	call	_release_buffer
	mov	eax, DWORD PTR [esi+8]
	add	esp, 8
	inc	edi
	cmp	edi, eax
	jb	SHORT $L69484
$L69486:

; 207  :   free(fs->groupdesc_buffers);

	mov	eax, DWORD PTR [esi+28]
	push	eax
	call	_free

; 208  :   free(fs->groups);

	mov	ecx, DWORD PTR [esi+32]
	push	ecx
	call	_free

; 209  : 
; 210  :   // Write super block
; 211  :   dev_write(fs->devno, fs->super, SECTORSIZE, 1);

	mov	edx, DWORD PTR [esi+20]
	mov	eax, DWORD PTR [esi]
	push	1
	push	512					; 00000200H
	push	edx
	push	eax
	call	_dev_write

; 212  :   free(fs->super);

	mov	ecx, DWORD PTR [esi+20]
	push	ecx
	call	_free

; 213  : 
; 214  :   // Flush buffer cache
; 215  :   flush_buffers(fs->cache);

	mov	edx, DWORD PTR [esi+24]
	push	edx
	call	_flush_buffers

; 216  : 
; 217  :   // Free cache
; 218  :   free_buffer_pool(fs->cache);

	mov	eax, DWORD PTR [esi+24]
	push	eax
	call	_free_buffer_pool

; 219  : 
; 220  :   // Deallocate file system
; 221  :   free(fs);

	push	esi
	call	_free
	add	esp, 40					; 00000028H
	pop	edi
	pop	esi

; 222  : }

	ret	0
_close_filesystem ENDP
_TEXT	ENDS
PUBLIC	_new_block
EXTRN	_find_next_zero_bit:NEAR
;	COMDAT _new_block
_TEXT	SEGMENT
_fs$ = 8
_goal$ = 12
_i$ = 12
_buf$ = 8
_block$ = -4
_new_block PROC NEAR					; COMDAT

; 225  : {

	sub	esp, 8
	push	ebx
	push	ebp

; 226  :   unsigned int group;
; 227  :   unsigned int i;
; 228  :   struct buf *buf;
; 229  :   blk_t block;
; 230  : 
; 231  :   if (goal < fs->super->block_count)

	mov	ebx, DWORD PTR _goal$[esp+12]
	push	esi
	mov	esi, DWORD PTR _fs$[esp+16]
	push	edi
	mov	eax, DWORD PTR [esi+20]
	cmp	ebx, DWORD PTR [eax+28]
	jae	$L69496

; 232  :   {
; 233  :     // Check the goal
; 234  :     group = goal / fs->super->blocks_per_group;

	mov	ecx, DWORD PTR [eax+40]
	mov	eax, ebx
	xor	edx, edx
	div	ecx

; 235  :     block = goal % fs->super->blocks_per_group;

	xor	edx, edx
	mov	edi, eax
	mov	eax, ebx
	div	ecx

; 236  :     buf = get_buffer(fs->cache, fs->groups[group].desc->block_bitmap_block);

	mov	eax, DWORD PTR [esi+32]
	lea	ebx, DWORD PTR [edi+edi*2]
	shl	ebx, 2
	mov	ecx, DWORD PTR [ebx+eax]
	mov	eax, DWORD PTR [esi+24]
	mov	ebp, edx
	mov	edx, DWORD PTR [ecx+4]
	push	edx
	push	eax
	mov	DWORD PTR _block$[esp+32], ebp
	call	_get_buffer
	mov	ecx, eax

; 237  :     if (!test_bit(buf->data, block))

	mov	eax, ebp
	cdq
	and	edx, 7
	mov	DWORD PTR _buf$[esp+28], ecx
	mov	ecx, DWORD PTR [ecx+28]
	add	eax, edx
	add	esp, 8
	mov	DWORD PTR -8+[esp+24], ecx
	sar	eax, 3
	and	ebp, -2147483641			; 80000007H
	jns	SHORT $L69582
	dec	ebp
	or	ebp, -8					; fffffff8H
	inc	ebp
$L69582:
	mov	edx, 1
	mov	ecx, ebp
	shl	edx, cl
	mov	ecx, DWORD PTR -8+[esp+24]
	test	BYTE PTR [ecx+eax], dl
	jne	SHORT $L69497

; 238  :     {
; 239  :       set_bit(buf->data, block);

	mov	edi, DWORD PTR -8+[esp+24]
	mov	dl, 1
	mov	ecx, ebp
	shl	dl, cl
	mov	cl, BYTE PTR [eax+edi]
	or	cl, dl
	mov	BYTE PTR [eax+edi], cl

; 240  :       if (fs->groups[group].first_free_block == block) fs->groups[group].first_free_block = block + 1;

	mov	eax, DWORD PTR [esi+32]
	mov	ecx, DWORD PTR [ebx+eax+4]
	lea	ebx, DWORD PTR [ebx+eax+4]
	mov	eax, DWORD PTR _block$[esp+24]
	cmp	ecx, eax
	jne	SHORT $L69498
	inc	eax
	mov	DWORD PTR [ebx], eax
$L69498:

; 241  :       mark_buffer_updated(buf);

	mov	edi, DWORD PTR _buf$[esp+20]
	push	edi
	call	_mark_buffer_updated

; 242  :       release_buffer(fs->cache, buf);

	mov	ecx, DWORD PTR [esi+24]
	push	edi
	push	ecx
	call	_release_buffer

; 243  :       return goal;

	mov	eax, DWORD PTR _goal$[esp+32]
	add	esp, 12					; 0000000cH
	pop	edi
	pop	esi
	pop	ebp
	pop	ebx

; 288  : }

	add	esp, 8
	ret	0
$L69497:

; 244  :     }
; 245  : 
; 246  :     // Try to find first free block in group after goal
; 247  :     block = find_next_zero_bit(buf->data, fs->groups[group].desc->block_count, block + 1);

	mov	edx, DWORD PTR _block$[esp+24]
	mov	eax, DWORD PTR [esi+32]
	inc	edx
	push	edx
	mov	edx, DWORD PTR [ebx+eax]
	mov	eax, DWORD PTR [edx]
	push	eax
	push	ecx
	call	_find_next_zero_bit

; 248  :     if (block != fs->groups[group].desc->block_count)

	mov	ecx, DWORD PTR [esi+32]
	mov	ebp, eax
	add	esp, 12					; 0000000cH
	mov	edx, DWORD PTR [ebx+ecx]
	cmp	ebp, DWORD PTR [edx]
	je	SHORT $L69499

; 249  :     {
; 250  :       set_bit(buf->data, block);

	mov	eax, DWORD PTR _buf$[esp+20]
	mov	ecx, DWORD PTR [eax+28]
	mov	eax, ebp
	cdq
	and	edx, 7
	add	eax, edx
	sar	eax, 3
	add	eax, ecx
	mov	ecx, ebp
	and	ecx, -2147483641			; 80000007H
	jns	SHORT $L69583
	dec	ecx
	or	ecx, -8					; fffffff8H
	inc	ecx
$L69583:
	mov	dl, 1
	shl	dl, cl
	mov	cl, BYTE PTR [eax]
	or	cl, dl
	mov	BYTE PTR [eax], cl

; 251  :       if (fs->groups[group].first_free_block == block) fs->groups[group].first_free_block = block + 1;

	mov	eax, DWORD PTR [esi+32]
	lea	ebx, DWORD PTR [ebx+eax+4]
	cmp	DWORD PTR [ebx], ebp
	jne	SHORT $L69500
	lea	ecx, DWORD PTR [ebp+1]
	mov	DWORD PTR [ebx], ecx
$L69500:

; 252  :       mark_buffer_updated(buf);

	mov	ebx, DWORD PTR _buf$[esp+20]
	push	ebx
	call	_mark_buffer_updated

; 253  :       release_buffer(fs->cache, buf);

	mov	edx, DWORD PTR [esi+24]
	push	ebx
	push	edx
	call	_release_buffer

; 254  :       return group * fs->super->blocks_per_group + block;

	mov	eax, DWORD PTR [esi+20]
	add	esp, 12					; 0000000cH
	mov	eax, DWORD PTR [eax+40]
	imul	eax, edi
	pop	edi
	add	eax, ebp
	pop	esi
	pop	ebp
	pop	ebx

; 288  : }

	add	esp, 8
	ret	0
$L69499:

; 255  :     }
; 256  : 
; 257  :     release_buffer(fs->cache, buf);

	mov	ecx, DWORD PTR _buf$[esp+20]
	mov	edx, DWORD PTR [esi+24]
	push	ecx
	push	edx
	call	_release_buffer
	add	esp, 8

; 258  :   }
; 259  :   else

	jmp	SHORT $L69501
$L69496:

; 260  :     group = 0;

	xor	edi, edi
$L69501:

; 261  : 
; 262  :   // Try to locate a free block by going through all blocks cyclicly
; 263  :   for (i = 0; i < fs->super->block_count; i++)

	mov	eax, DWORD PTR [esi+20]
	mov	DWORD PTR _i$[esp+20], 0
	mov	ecx, DWORD PTR [eax+28]
	test	ecx, ecx
	jbe	SHORT $L69504
$L69502:

; 264  :   {
; 265  :     // Get block bitmap
; 266  :     buf = get_buffer(fs->cache, fs->groups[group].desc->block_bitmap_block);

	mov	ecx, DWORD PTR [esi+32]
	lea	ebx, DWORD PTR [edi+edi*2]
	shl	ebx, 2
	mov	edx, DWORD PTR [ebx+ecx]
	mov	ecx, DWORD PTR [esi+24]
	mov	eax, DWORD PTR [edx+4]
	push	eax
	push	ecx
	call	_get_buffer

; 267  : 
; 268  :     // Try to find first free block
; 269  :     block = find_next_zero_bit(buf->data, fs->groups[group].desc->block_count, fs->groups[group].first_free_block);

	mov	edx, DWORD PTR [esi+32]
	mov	DWORD PTR _buf$[esp+28], eax
	mov	eax, DWORD PTR [eax+28]
	lea	ecx, DWORD PTR [ebx+edx]
	mov	edx, DWORD PTR [ebx+edx+4]
	mov	ecx, DWORD PTR [ecx]
	push	edx
	mov	edx, DWORD PTR [ecx]
	push	edx
	push	eax
	call	_find_next_zero_bit

; 270  :     if (block != fs->groups[group].desc->block_count)

	mov	ecx, DWORD PTR [esi+32]
	mov	ebp, eax
	add	esp, 20					; 00000014H
	mov	edx, DWORD PTR [ebx+ecx]
	cmp	ebp, DWORD PTR [edx]
	jne	SHORT $L69580

; 277  :     }
; 278  :     
; 279  :     release_buffer(fs->cache, buf);

	mov	eax, DWORD PTR _buf$[esp+20]
	mov	ecx, DWORD PTR [esi+24]
	push	eax
	push	ecx
	call	_release_buffer

; 280  : 
; 281  :     // Try next group
; 282  :     group++;
; 283  :     if (group >= fs->super->block_count) group = 0;

	mov	edx, DWORD PTR [esi+20]
	add	esp, 8
	inc	edi
	mov	eax, DWORD PTR [edx+28]
	cmp	edi, eax
	jb	SHORT $L69503
	xor	edi, edi
$L69503:

; 261  : 
; 262  :   // Try to locate a free block by going through all blocks cyclicly
; 263  :   for (i = 0; i < fs->super->block_count; i++)

	mov	ecx, DWORD PTR _i$[esp+20]
	inc	ecx
	cmp	ecx, eax
	mov	DWORD PTR _i$[esp+20], ecx
	jb	SHORT $L69502
$L69504:
	pop	edi
	pop	esi
	pop	ebp

; 284  :   }
; 285  : 
; 286  :   //panic("disk full");
; 287  :   return -1;

	or	eax, -1
	pop	ebx

; 288  : }

	add	esp, 8
	ret	0
$L69580:

; 271  :     {
; 272  :       set_bit(buf->data, block);

	mov	ebx, DWORD PTR _buf$[esp+20]
	mov	eax, ebp
	cdq
	mov	ecx, DWORD PTR [ebx+28]
	and	edx, 7
	add	eax, edx
	sar	eax, 3
	add	eax, ecx
	mov	ecx, ebp
	and	ecx, -2147483641			; 80000007H
	jns	SHORT $L69584
	dec	ecx
	or	ecx, -8					; fffffff8H
	inc	ecx
$L69584:
	mov	dl, 1
	shl	dl, cl
	mov	cl, BYTE PTR [eax]
	or	cl, dl
	mov	BYTE PTR [eax], cl

; 273  :       if (fs->groups[group].first_free_block == block) fs->groups[group].first_free_block = block + 1;

	mov	ecx, DWORD PTR [esi+32]
	lea	eax, DWORD PTR [edi+edi*2]
	lea	eax, DWORD PTR [ecx+eax*4+4]
	cmp	DWORD PTR [eax], ebp
	jne	SHORT $L69506
	lea	edx, DWORD PTR [ebp+1]
	mov	DWORD PTR [eax], edx
$L69506:

; 274  :       mark_buffer_updated(buf);

	push	ebx
	call	_mark_buffer_updated

; 275  :       release_buffer(fs->cache, buf);

	mov	eax, DWORD PTR [esi+24]
	push	ebx
	push	eax
	call	_release_buffer

; 276  :       return group * fs->super->blocks_per_group + block;

	mov	ecx, DWORD PTR [esi+20]
	add	esp, 12					; 0000000cH
	mov	eax, DWORD PTR [ecx+40]
	imul	eax, edi
	pop	edi
	add	eax, ebp
	pop	esi
	pop	ebp
	pop	ebx

; 288  : }

	add	esp, 8
	ret	0
_new_block ENDP
_TEXT	ENDS
END
