	TITLE	C:\sanos\emul\src\os\critsect.c
	.386P
include listing.inc
if @Version gt 510
.model FLAT
else
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
_DATA	SEGMENT DWORD USE32 PUBLIC 'DATA'
_DATA	ENDS
CONST	SEGMENT DWORD USE32 PUBLIC 'CONST'
CONST	ENDS
_BSS	SEGMENT DWORD USE32 PUBLIC 'BSS'
_BSS	ENDS
_TLS	SEGMENT DWORD USE32 PUBLIC 'TLS'
_TLS	ENDS
;	COMDAT _atomic_add
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
;	COMDAT _init_critsect
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
;	COMDAT _delete_critsect
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
;	COMDAT _enter_critsect
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
;	COMDAT _leave_critsect
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
FLAT	GROUP _DATA, CONST, _BSS
	ASSUME	CS: FLAT, DS: FLAT, SS: FLAT
endif
PUBLIC	_init_critsect
EXTRN	_create_event:NEAR
;	COMDAT _init_critsect
_TEXT	SEGMENT
_cs$ = 8
_init_critsect PROC NEAR				; COMDAT

; 17   : {

	push	esi

; 18   :   cs->count = -1;

	mov	esi, DWORD PTR _cs$[esp]

; 19   :   cs->recursion = 0;
; 20   :   cs->owner = NOHANDLE;
; 21   :   cs->event = create_event(0, 0);

	push	0
	push	0
	mov	DWORD PTR [esi], -1
	mov	DWORD PTR [esi+4], 0
	mov	DWORD PTR [esi+8], -1
	call	_create_event
	add	esp, 8
	mov	DWORD PTR [esi+12], eax
	pop	esi

; 22   : }

	ret	0
_init_critsect ENDP
_TEXT	ENDS
PUBLIC	_delete_critsect
EXTRN	_close_handle:NEAR
;	COMDAT _delete_critsect
_TEXT	SEGMENT
_cs$ = 8
_delete_critsect PROC NEAR				; COMDAT

; 26   :   close_handle(cs->event);

	mov	eax, DWORD PTR _cs$[esp-4]
	mov	ecx, DWORD PTR [eax+12]
	push	ecx
	call	_close_handle
	pop	ecx

; 27   : }

	ret	0
_delete_critsect ENDP
_TEXT	ENDS
PUBLIC	_enter_critsect
EXTRN	_get_current_thread:NEAR
EXTRN	_wait_for_object:NEAR
;	COMDAT _enter_critsect
_TEXT	SEGMENT
_cs$ = 8
_enter_critsect PROC NEAR				; COMDAT

; 30   : {

	push	ebp
	mov	ebp, esp
	push	esi
	push	edi

; 31   :   handle_t self = get_current_thread();

	call	_get_current_thread

; 32   : 
; 33   :   if (cs->owner == self)

	mov	esi, DWORD PTR _cs$[ebp]
	mov	edi, eax
	cmp	DWORD PTR [esi+8], edi
	jne	SHORT $L725

; 35   :     cs->recursion++;

	mov	eax, DWORD PTR [esi+4]
	pop	edi
	inc	eax
	mov	DWORD PTR [esi+4], eax
	pop	esi

; 41   :   }
; 42   : }

	pop	ebp
	ret	0
$L725:

; 32   : 
; 33   :   if (cs->owner == self)

	mov	edx, DWORD PTR _cs$[ebp]

; 34   :   {

	mov	eax, 1

; 35   :     cs->recursion++;

	mov	ecx, eax

; 36   :   }

	lock	 xadd	 DWORD PTR [edx], eax

; 37   :   else 

	add	eax, ecx

; 38   :   {    
; 39   :     if (atomic_add(&cs->count, 1) > 0)  wait_for_object(cs->event, INFINITE);

	test	eax, eax
	jle	SHORT $L727
	mov	eax, DWORD PTR [esi+12]
	push	-1
	push	eax
	call	_wait_for_object
	add	esp, 8
$L727:

; 40   :     cs->owner = self;

	mov	DWORD PTR [esi+8], edi
	pop	edi
	pop	esi

; 41   :   }
; 42   : }

	pop	ebp
	ret	0
_enter_critsect ENDP
_TEXT	ENDS
PUBLIC	_leave_critsect
EXTRN	_set_event:NEAR
;	COMDAT _leave_critsect
_TEXT	SEGMENT
_cs$ = 8
_leave_critsect PROC NEAR				; COMDAT

; 45   : {

	push	ebp
	mov	ebp, esp
	push	esi

; 46   :   handle_t self = get_current_thread();

	call	_get_current_thread

; 47   : 
; 48   :   if (cs->owner != self) return;

	mov	esi, DWORD PTR _cs$[ebp]
	cmp	DWORD PTR [esi+8], eax
	jne	SHORT $L736

; 49   :   if (cs->recursion > 0)

	mov	eax, DWORD PTR [esi+4]
	test	eax, eax
	jle	SHORT $L733

; 51   :     cs->recursion--;

	dec	eax
	mov	DWORD PTR [esi+4], eax
	pop	esi

; 57   :   }
; 58   : }

	pop	ebp
	ret	0
$L733:

; 53   :   else
; 54   :   {
; 55   :     cs->owner = NOHANDLE;

	mov	DWORD PTR [esi+8], -1

; 47   : 
; 48   :   if (cs->owner != self) return;

	mov	edx, DWORD PTR _cs$[ebp]

; 49   :   if (cs->recursion > 0)

	mov	eax, -1

; 50   :   {

	mov	ecx, eax

; 51   :     cs->recursion--;

	lock	 xadd	 DWORD PTR [edx], eax

; 52   :   }

	add	eax, ecx

; 56   :     if (atomic_add(&cs->count, -1) >= 0) set_event(cs->event);

	test	eax, eax
	jl	SHORT $L736
	mov	eax, DWORD PTR [esi+12]
	push	eax
	call	_set_event
	add	esp, 4
$L736:
	pop	esi

; 57   :   }
; 58   : }

	pop	ebp
	ret	0
_leave_critsect ENDP
_TEXT	ENDS
END
