	TITLE	C:\sanos\emul\src\os\heap.c
	.386P
include listing.inc
if @Version gt 510
.model FLAT
else
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
_DATA	SEGMENT DWORD USE32 PUBLIC 'DATA'
_DATA	ENDS
CONST	SEGMENT DWORD USE32 PUBLIC 'CONST'
CONST	ENDS
_BSS	SEGMENT PARA USE32 PUBLIC 'BSS'
_BSS	ENDS
_TLS	SEGMENT DWORD USE32 PUBLIC 'TLS'
_TLS	ENDS
;	COMDAT ??_C@_0BE@DEG@Big?5allocation?5?$CFdK?6?$AA@
_DATA	SEGMENT DWORD USE32 PUBLIC 'DATA'
_DATA	ENDS
;	COMDAT ??_C@_0BO@DBPD@unable?5to?5reserve?5heap?5region?$AA@
_DATA	SEGMENT DWORD USE32 PUBLIC 'DATA'
_DATA	ENDS
;	COMDAT ??_C@_0DL@IEHD@Expand?5heap?3?5request?5?$DN?5?$CFd?0?5remai@
_DATA	SEGMENT DWORD USE32 PUBLIC 'DATA'
_DATA	ENDS
;	COMDAT ??_C@_0O@OAFC@out?5of?5memory?$AA@
_DATA	SEGMENT DWORD USE32 PUBLIC 'DATA'
_DATA	ENDS
;	COMDAT ??_C@_0BG@HFBC@unable?5to?5expand?5heap?$AA@
_DATA	SEGMENT DWORD USE32 PUBLIC 'DATA'
_DATA	ENDS
;	COMDAT ??_C@_0BF@CCMK@Reserve?5heap?5region?6?$AA@
_DATA	SEGMENT DWORD USE32 PUBLIC 'DATA'
_DATA	ENDS
;	COMDAT ??_C@_0BL@HPOG@Expand?5heap?5to?5?$CFd?5KB?5?$CI?$CFd?$CJ?6?$AA@
_DATA	SEGMENT DWORD USE32 PUBLIC 'DATA'
_DATA	ENDS
;	COMDAT ??_C@_0CG@NNBH@Heap?5Trim?5called?3?5top?5remaining?5@
_DATA	SEGMENT DWORD USE32 PUBLIC 'DATA'
_DATA	ENDS
;	COMDAT ??_C@_0BJ@MAPF@Free?5big?5chunk?5?$CFdK?5?$CI?$CFd?$CJ?6?$AA@
_DATA	SEGMENT DWORD USE32 PUBLIC 'DATA'
_DATA	ENDS
;	COMDAT _heap_init
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
;	COMDAT _heap_consolidate
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
;	COMDAT _sysalloc
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
;	COMDAT _systrim
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
;	COMDAT _heap_alloc
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
;	COMDAT _heap_free
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
;	COMDAT _heap_realloc
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
;	COMDAT _heap_calloc
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
FLAT	GROUP _DATA, CONST, _BSS
	ASSUME	CS: FLAT, DS: FLAT, SS: FLAT
endif
_BSS	SEGMENT
_region	DD	01H DUP (?)
_wilderness DD	01H DUP (?)
_heapend DD	01H DUP (?)
_BSS	ENDS
PUBLIC	_heap_alloc
_BSS	SEGMENT
_mainheap DB	045cH DUP (?)
_BSS	ENDS
;	COMDAT _heap_alloc
_TEXT	SEGMENT
_bytes$ = 8
_idx$ = 8
_heap_alloc PROC NEAR					; COMDAT

; 786  : {

	push	ecx

; 787  :   struct heap *av = get_malloc_state();
; 788  : 
; 789  :   size_t          nb;               // normalized request size
; 790  :   unsigned int    idx;              // associated bin index
; 791  :   mbinptr         bin;              // associated bin
; 792  :   mfastbinptr*    fb;               // associated fastbin
; 793  : 
; 794  :   mchunkptr       victim;           // inspected/selected chunk
; 795  :   size_t          size;             // its size
; 796  :   int             victim_index;     // its bin index
; 797  : 
; 798  :   mchunkptr       remainder;        // remainder from a split
; 799  :   unsigned long   remainder_size;   // its size
; 800  : 
; 801  :   unsigned int    block;            // bit map traverser
; 802  :   unsigned int    bit;              // bit map traverser
; 803  :   unsigned int    map;              // current word of binmap
; 804  : 
; 805  :   mchunkptr       fwd;              // misc temp for linking
; 806  :   mchunkptr       bck;              // misc temp for linking
; 807  : 
; 808  :   // Convert request size to internal form by adding sizeof(size_t) bytes
; 809  :   // overhead plus possibly more to obtain necessary alignment and/or
; 810  :   // to obtain a size of at least MINSIZE, the smallest allocatable
; 811  :   // size. 
; 812  : 
; 813  :   nb = request2size(bytes);

	mov	eax, DWORD PTR _bytes$[esp]
	push	ebx
	push	ebp
	push	esi
	lea	ebx, DWORD PTR [eax+11]
	push	edi
	cmp	ebx, 16					; 00000010H
	jae	SHORT $L1076
	mov	ebx, 16					; 00000010H
	jmp	SHORT $L1077
$L1076:
	and	ebx, -8					; fffffff8H
$L1077:

; 814  : 
; 815  :   // If the size qualifies as a fastbin, first check corresponding bin.
; 816  :   // This code is safe to execute even if av is not yet initialized, so we
; 817  :   // can try it without checking, which saves some time on this fast path.
; 818  : 
; 819  :   if (nb <= av->max_fast)

	mov	edx, DWORD PTR _mainheap
	cmp	ebx, edx
	ja	SHORT $L722

; 820  :   { 
; 821  :     fb = &(av->fastbins[(fastbin_index(nb))]);

	mov	ecx, ebx
	shr	ecx, 3

; 822  :     if ( (victim = *fb) != 0) 

	mov	eax, DWORD PTR _mainheap[ecx*4-4]
	lea	ecx, DWORD PTR _mainheap[ecx*4-4]
	test	eax, eax
	je	SHORT $L722

; 823  :     {
; 824  :       *fb = victim->fd;

	mov	edx, DWORD PTR [eax+8]
	add	eax, 8
	pop	edi
	pop	esi
	pop	ebp
	mov	DWORD PTR [ecx], edx
	pop	ebx

; 1125 : }

	pop	ecx
	ret	0
$L722:

; 825  :       return chunk2mem(victim);
; 826  :     }
; 827  :   }
; 828  : 
; 829  :   // If a small request, check regular bin.  Since these "smallbins"
; 830  :   // hold one size each, no searching within bins is necessary.
; 831  :   // (For a large request, we need to wait until unsorted chunks are
; 832  :   // processed to find best fit. But for small ones, fits are exact
; 833  :   // anyway, so we can check now, which is faster.)
; 834  : 
; 835  :   if (in_smallbin_range(nb)) 

	cmp	ebx, 512				; 00000200H
	jae	SHORT $L726

; 836  :   {
; 837  :     idx = smallbin_index(nb);

	mov	ebp, ebx
	shr	ebp, 3
	mov	DWORD PTR _idx$[esp+16], ebp

; 838  :     bin = bin_at(av,idx);
; 839  : 
; 840  :     if ((victim = last(bin)) != bin) 

	mov	eax, DWORD PTR _mainheap[ebp*8+56]
	lea	ecx, DWORD PTR _mainheap[ebp*8+44]
	cmp	eax, ecx
	je	$L741

; 841  :     {
; 842  :       if (victim == 0) // initialization check

	test	eax, eax
	jne	SHORT $L731

; 843  :         heap_consolidate(av);

	push	OFFSET FLAT:_mainheap
	call	_heap_consolidate
	add	esp, 4

; 844  :       else 

	jmp	$L741
$L731:

; 845  :       {
; 846  :         bck = victim->bk;
; 847  :         set_inuse_bit_at_offset(victim, nb);

	mov	esi, DWORD PTR [eax+ebx+4]
	mov	edx, DWORD PTR [eax+12]
	or	esi, 1
	pop	edi
	mov	DWORD PTR [eax+ebx+4], esi
	pop	esi

; 848  :         bin->bk = bck;

	mov	DWORD PTR [ecx+12], edx
	pop	ebp

; 849  :         bck->fd = bin;

	mov	DWORD PTR [edx+8], ecx

; 850  :         
; 851  :         return chunk2mem(victim);

	add	eax, 8
	pop	ebx

; 1125 : }

	pop	ecx
	ret	0
$L726:

; 852  :       }
; 853  :     }
; 854  :   }
; 855  : 
; 856  :   // If this is a large request, consolidate fastbins before continuing.
; 857  :   // While it might look excessive to kill all fastbins before
; 858  :   // even seeing if there is space available, this avoids
; 859  :   // fragmentation problems normally associated with fastbins.
; 860  :   // Also, in practice, programs tend to have runs of either small or
; 861  :   // large requests, but less often mixtures, so consolidation is not 
; 862  :   // invoked all that often in most programs. And the programs that
; 863  :   // it is called frequently in otherwise tend to fragment.
; 864  : 
; 865  :   else 
; 866  :   {
; 867  :     idx = largebin_index(nb);

	mov	eax, ebx
	and	al, -64					; ffffffc0H
	cmp	eax, 2048				; 00000800H
	ja	SHORT $L1086
	mov	eax, ebx
	shr	eax, 6
	add	eax, 56					; 00000038H
	mov	DWORD PTR _idx$[esp+16], eax
	jmp	SHORT $L1079
$L1086:
	mov	ecx, ebx
	mov	eax, ebx
	and	ecx, -512				; fffffe00H
	cmp	ecx, 10240				; 00002800H
	ja	SHORT $L1084
	shr	eax, 9
	add	eax, 91					; 0000005bH
	mov	DWORD PTR _idx$[esp+16], eax
	jmp	SHORT $L1079
$L1084:
	and	eax, -4096				; fffff000H
	cmp	eax, 40960				; 0000a000H
	ja	SHORT $L1082
	mov	eax, ebx
	shr	eax, 12					; 0000000cH
	add	eax, 110				; 0000006eH
	mov	DWORD PTR _idx$[esp+16], eax
	jmp	SHORT $L1079
$L1082:
	mov	ecx, ebx
	mov	eax, ebx
	and	ecx, -32768				; ffff8000H
	cmp	ecx, 131072				; 00020000H
	ja	SHORT $L1080
	shr	eax, 15					; 0000000fH
	add	eax, 119				; 00000077H
	mov	DWORD PTR _idx$[esp+16], eax
	jmp	SHORT $L1079
$L1080:
	and	eax, -262144				; fffc0000H
	cmp	eax, 524288				; 00080000H
	ja	SHORT $L1078
	mov	eax, ebx
	shr	eax, 18					; 00000012H
	add	eax, 124				; 0000007cH
	mov	DWORD PTR _idx$[esp+16], eax
	jmp	SHORT $L1079
$L1078:
	mov	DWORD PTR _idx$[esp+16], 126		; 0000007eH
$L1079:

; 868  :     if (have_fastchunks(av)) heap_consolidate(av);

	test	dl, 1
	jne	SHORT $L1122
	push	OFFSET FLAT:_mainheap
	call	_heap_consolidate
	add	esp, 4
$L1122:
	mov	ebp, DWORD PTR _idx$[esp+16]
$L741:

; 869  :   }
; 870  : 
; 871  :   // Process recently freed or remaindered chunks, taking one only if
; 872  :   // it is exact fit, or, if this a small request, the chunk is remainder from
; 873  :   // the most recent non-exact fit.  Place other traversed chunks in
; 874  :   // bins.  Note that this step is the only place in any routine where
; 875  :   // chunks are placed in bins.
; 876  :   // 
; 877  :   // The outer loop here is needed because we might not realize until
; 878  :   // near the end of malloc that we should have consolidated, so must
; 879  :   // do so and retry. This happens at most once, and only when we would
; 880  :   // otherwise need to expand memory to service a "small" request.
; 881  :     
; 882  :   for(;;) 
; 883  :   {    
; 884  :     
; 885  :     while ((victim = unsorted_chunks(av)->bk) != unsorted_chunks(av)) 

	mov	ecx, DWORD PTR _mainheap+64
	cmp	ecx, OFFSET FLAT:_mainheap+52
	mov	edi, ecx
	je	$L751
$L750:

; 886  :     {
; 887  :       bck = victim->bk;

	mov	edx, DWORD PTR [ecx+12]
	lea	eax, DWORD PTR [ecx+12]
	mov	DWORD PTR -4+[esp+20], eax

; 888  :       size = chunksize(victim);

	mov	eax, DWORD PTR [ecx+4]
	and	al, -4					; fffffffcH

; 889  : 
; 890  :       // If a small request, try to use last remainder if it is the
; 891  :       // only chunk in unsorted bin.  This helps promote locality for
; 892  :       // runs of consecutive small requests. This is the only
; 893  :       // exception to best-fit, and applies only when there is
; 894  :       // no exact fit for a small chunk.
; 895  : 
; 896  :       if (in_smallbin_range(nb) && bck == unsorted_chunks(av) && victim == av->last_remainder && size > nb + MINSIZE)

	cmp	ebx, 512				; 00000200H
	jae	SHORT $L759
	cmp	edx, OFFSET FLAT:_mainheap+52
	jne	SHORT $L759
	cmp	ecx, DWORD PTR _mainheap+48
	jne	SHORT $L759
	lea	ecx, DWORD PTR [ebx+16]
	cmp	eax, ecx
	ja	$L1105
$L759:

; 910  :       }
; 911  : 
; 912  :       // Remove from unsorted list
; 913  :       unsorted_chunks(av)->bk = bck;

	mov	DWORD PTR _mainheap+64, edx

; 914  :       bck->fd = unsorted_chunks(av);
; 915  :       
; 916  :       // Take now instead of binning if exact fit
; 917  :       if (size == nb) 

	cmp	eax, ebx
	mov	DWORD PTR [edx+8], OFFSET FLAT:_mainheap+52
	je	$L1106

; 921  :       }
; 922  :       
; 923  :       // Place chunk in bin
; 924  :       if (in_smallbin_range(size)) 

	cmp	eax, 512				; 00000200H
	jae	SHORT $L788

; 925  :       {
; 926  :         victim_index = smallbin_index(size);

	shr	eax, 3
	mov	ecx, eax

; 927  :         bck = bin_at(av, victim_index);
; 928  :         fwd = bck->fd;

	mov	esi, DWORD PTR _mainheap[ecx*8+52]
	lea	edx, DWORD PTR _mainheap[ecx*8+44]

; 929  :       }
; 930  :       else 

	jmp	$L798
$L788:

; 931  :       {
; 932  :         victim_index = largebin_index(size);

	mov	edx, eax
	mov	ecx, eax
	and	edx, -64				; ffffffc0H
	cmp	edx, 2048				; 00000800H
	ja	SHORT $L1096
	shr	ecx, 6
	add	ecx, 56					; 00000038H
	jmp	SHORT $L1089
$L1096:
	and	ecx, -512				; fffffe00H
	cmp	ecx, 10240				; 00002800H
	ja	SHORT $L1094
	mov	ecx, eax
	shr	ecx, 9
	add	ecx, 91					; 0000005bH
	jmp	SHORT $L1089
$L1094:
	mov	edx, eax
	mov	ecx, eax
	and	edx, -4096				; fffff000H
	cmp	edx, 40960				; 0000a000H
	ja	SHORT $L1092
	shr	ecx, 12					; 0000000cH
	add	ecx, 110				; 0000006eH
	jmp	SHORT $L1089
$L1092:
	and	ecx, -32768				; ffff8000H
	cmp	ecx, 131072				; 00020000H
	ja	SHORT $L1090
	mov	ecx, eax
	shr	ecx, 15					; 0000000fH
	add	ecx, 119				; 00000077H
	jmp	SHORT $L1089
$L1090:
	mov	edx, eax
	and	edx, -262144				; fffc0000H
	cmp	edx, 524288				; 00080000H
	ja	SHORT $L1088
	mov	ecx, eax
	shr	ecx, 18					; 00000012H
	add	ecx, 124				; 0000007cH
	jmp	SHORT $L1089
$L1088:
	mov	ecx, 126				; 0000007eH
$L1089:

; 933  :         bck = bin_at(av, victim_index);
; 934  :         fwd = bck->fd;

	mov	esi, DWORD PTR _mainheap[ecx*8+52]
	lea	edx, DWORD PTR _mainheap[ecx*8+44]

; 935  : 
; 936  :         // Maintain large bins in sorted order
; 937  :         if (fwd != bck) 

	cmp	esi, edx
	je	SHORT $L798

; 938  : 	{
; 939  : 	  // Or with inuse bit to speed comparisons
; 940  :           size |= PREV_INUSE;
; 941  : 
; 942  :           // If smaller than smallest, bypass loop below
; 943  :           if (size <= bck->bk->size) 

	mov	ebp, DWORD PTR [edx+12]
	or	al, 1
	cmp	eax, DWORD PTR [ebp+4]
	ja	SHORT $L1100

; 944  : 	  {
; 945  :             fwd = bck;

	mov	esi, edx

; 946  :             bck = bck->bk;

	mov	edx, ebp

; 947  :           }
; 948  :           else 

	jmp	SHORT $L798
$L1100:

; 949  : 	  {
; 950  :             while (size < fwd->size) fwd = fwd->fd;

	cmp	eax, DWORD PTR [esi+4]
	jae	SHORT $L801
$L800:
	mov	esi, DWORD PTR [esi+8]
	cmp	eax, DWORD PTR [esi+4]
	jb	SHORT $L800
$L801:

; 951  :             bck = fwd->bk;

	mov	edx, DWORD PTR [esi+12]
$L798:

; 952  :           }
; 953  :         }
; 954  :       }
; 955  :       
; 956  :       mark_bin(av, victim_index);

	mov	eax, ecx
	and	ecx, 31					; 0000001fH
	sar	eax, 5
	mov	ebp, 1
	lea	eax, DWORD PTR _mainheap[eax*4+1076]
	shl	ebp, cl
	mov	ecx, DWORD PTR [eax]
	or	ecx, ebp
	mov	DWORD PTR [eax], ecx

; 957  :       victim->bk = bck;

	mov	ecx, DWORD PTR -4+[esp+20]

; 958  :       victim->fd = fwd;

	mov	DWORD PTR [edi+8], esi
	mov	DWORD PTR [ecx], edx

; 959  :       fwd->bk = victim;

	mov	DWORD PTR [esi+12], edi

; 960  :       bck->fd = victim;

	mov	DWORD PTR [edx+8], edi
	mov	ecx, DWORD PTR _mainheap+64
	cmp	ecx, OFFSET FLAT:_mainheap+52
	mov	edi, ecx
	jne	$L750

; 869  :   }
; 870  : 
; 871  :   // Process recently freed or remaindered chunks, taking one only if
; 872  :   // it is exact fit, or, if this a small request, the chunk is remainder from
; 873  :   // the most recent non-exact fit.  Place other traversed chunks in
; 874  :   // bins.  Note that this step is the only place in any routine where
; 875  :   // chunks are placed in bins.
; 876  :   // 
; 877  :   // The outer loop here is needed because we might not realize until
; 878  :   // near the end of malloc that we should have consolidated, so must
; 879  :   // do so and retry. This happens at most once, and only when we would
; 880  :   // otherwise need to expand memory to service a "small" request.
; 881  :     
; 882  :   for(;;) 
; 883  :   {    
; 884  :     
; 885  :     while ((victim = unsorted_chunks(av)->bk) != unsorted_chunks(av)) 

	mov	ebp, DWORD PTR _idx$[esp+16]
$L751:

; 961  :     }
; 962  :    
; 963  :     // If a large request, scan through the chunks of current bin in
; 964  :     // sorted order to find smallest that fits.  This is the only step
; 965  :     // where an unbounded number of chunks might be scanned without doing
; 966  :     // anything useful with them. However the lists tend to be short.
; 967  :       
; 968  :     if (!in_smallbin_range(nb)) 

	cmp	ebx, 512				; 00000200H
	jb	SHORT $L820

; 969  :     {
; 970  :       bin = bin_at(av, idx);
; 971  : 
; 972  :       // Skip scan if empty or largest chunk is too small
; 973  :       if ((victim = last(bin)) != bin && first(bin)->size >= nb) 

	mov	ecx, DWORD PTR _mainheap[ebp*8+56]
	lea	eax, DWORD PTR _mainheap[ebp*8+44]
	cmp	ecx, eax
	je	SHORT $L820
	mov	edx, DWORD PTR [eax+8]
	cmp	DWORD PTR [edx+4], ebx
	jae	$L1101
$L820:

; 995  :           return chunk2mem(victim);
; 996  :         } 
; 997  :       }
; 998  :     }    
; 999  : 
; 1000 :     // Search for a chunk by scanning bins, starting with next largest
; 1001 :     // bin. This search is strictly by best-fit; i.e., the smallest
; 1002 :     // (with ties going to approximately the least recently used) chunk
; 1003 :     // that fits is selected.
; 1004 :     
; 1005 :     // The bitmap avoids needing to check that most blocks are nonempty.
; 1006 :     // The particular case of skipping all bins during warm-up phases
; 1007 :     // when no chunks have been returned yet is faster than it might look.
; 1008 :     
; 1009 :     idx++;

	inc	ebp

; 1010 :     bin = bin_at(av,idx);
; 1011 :     block = idx2block(idx);
; 1012 :     map = av->binmap[block];
; 1013 :     bit = idx2bit(idx);

	mov	eax, 1
	mov	edi, ebp
	mov	ecx, ebp
	shr	edi, 5
	and	ecx, 31					; 0000001fH
	lea	edx, DWORD PTR _mainheap[ebp*8+44]
	mov	esi, DWORD PTR _mainheap[edi*4+1076]
	shl	eax, cl
$L841:

; 1014 :     
; 1015 :     for (;;) 
; 1016 :     {
; 1017 :       // Skip rest of block if there are no more set bits in this block.
; 1018 :       if (bit > map || bit == 0) 

	cmp	eax, esi
	ja	SHORT $L1103
	test	eax, eax
	jne	SHORT $L1104
$L1103:

; 1019 :       {
; 1020 :         do { if (++block >= BINMAPSIZE) goto use_top; } while ((map = av->binmap[block]) == 0);

	lea	eax, DWORD PTR _mainheap[edi*4+1076]
$L845:
	add	eax, 4
	inc	edi
	cmp	eax, OFFSET FLAT:_mainheap+1092
	jae	SHORT $use_top$849
	mov	esi, DWORD PTR [eax]
	test	esi, esi
	je	SHORT $L845

; 1021 :         bin = bin_at(av, (block << BINMAPSHIFT));

	mov	edx, edi

; 1022 :         bit = 1;

	mov	eax, 1
	shl	edx, 8
	add	edx, OFFSET FLAT:_mainheap+44
$L1104:

; 1023 :       }
; 1024 :       
; 1025 :       // Advance to bin with set bit. There must be one.
; 1026 :       while ((bit & map) == 0) 

	test	eax, esi
	jne	SHORT $L855
$L854:

; 1027 :       {
; 1028 :         bin = next_bin(bin);
; 1029 :         bit <<= 1;

	shl	eax, 1
	add	edx, 8
	test	eax, esi
	je	SHORT $L854
$L855:

; 1030 :         assert(bit != 0);
; 1031 :       }
; 1032 :       
; 1033 :       // Inspect the bin. It is likely to be non-empty
; 1034 :       victim = last(bin);

	mov	ecx, DWORD PTR [edx+12]

; 1035 :       
; 1036 :       //  If a false alarm (empty bin), clear the bit.
; 1037 :       if (victim == bin) 

	cmp	ecx, edx
	jne	$L859

; 1038 :       {
; 1039 :         av->binmap[block] = map &= ~bit; // Write through

	mov	ecx, eax

; 1040 :         bin = next_bin(bin);

	add	edx, 8
	not	ecx
	and	esi, ecx
	mov	DWORD PTR _mainheap[edi*4+1076], esi

; 1041 :         bit <<= 1;

	shl	eax, 1

; 1079 :         }
; 1080 :       }
; 1081 :     }

	jmp	SHORT $L841
$use_top$849:

; 1082 : 
; 1083 :   use_top:    
; 1084 :     // If large enough, split off the chunk bordering the end of memory
; 1085 :     // (held in av->top). Note that this is in accord with the best-fit
; 1086 :     // search rule.  In effect, av->top is treated as larger (and thus
; 1087 :     // less well fitting) than any other available chunk since it can
; 1088 :     // be extended to be as large as necessary (up to system
; 1089 :     // limitations).
; 1090 :     // 
; 1091 :     // We require that av->top always exists (i.e., has size >=
; 1092 :     // MINSIZE) after initialization, so if it would otherwise be
; 1093 :     // exhuasted by current request, it is replenished. (The main
; 1094 :     // reason for ensuring it exists is that we may need MINSIZE space
; 1095 :     // to put in fenceposts in sysmalloc.)
; 1096 : 
; 1097 :     victim = av->top;

	mov	ecx, DWORD PTR _mainheap+44

; 1098 :     size = chunksize(victim);
; 1099 :    
; 1100 :     if (size >= nb + MINSIZE)

	lea	edx, DWORD PTR [ebx+16]
	mov	eax, DWORD PTR [ecx+4]
	and	al, -4					; fffffffcH
	cmp	eax, edx
	jae	$L1109

; 1107 : 
; 1108 :       return chunk2mem(victim);
; 1109 :     }
; 1110 : 
; 1111 :     // If there is space available in fastbins, consolidate and retry,
; 1112 :     // to possibly avoid expanding memory. This can occur only if nb is
; 1113 :     // in smallbin range so we didn't consolidate upon entry.
; 1114 : 
; 1115 :     else if (have_fastchunks(av)) 

	mov	al, BYTE PTR _mainheap

; 1116 :     {
; 1117 :       assert(in_smallbin_range(nb));
; 1118 :       heap_consolidate(av);

	push	OFFSET FLAT:_mainheap
	test	al, 1
	jne	$L903
	call	_heap_consolidate

; 1119 :       idx = smallbin_index(nb); // restore original bin index

	mov	eax, ebx
	add	esp, 4
	shr	eax, 3
	mov	DWORD PTR _idx$[esp+16], eax

; 1124 :   }

	jmp	$L1122
$L1101:

; 974  :       {
; 975  :         while ((size = chunksize(victim)) < nb) victim = victim->bk;

	mov	edx, DWORD PTR [ecx+4]
	and	edx, -4					; fffffffcH
	cmp	edx, ebx
	jae	SHORT $L809
$L808:
	mov	ecx, DWORD PTR [ecx+12]
	mov	edx, DWORD PTR [ecx+4]
	and	edx, -4					; fffffffcH
	cmp	edx, ebx
	jb	SHORT $L808
$L809:

; 976  : 
; 977  :         remainder_size = size - nb;
; 978  :         unlink(victim, bck, fwd);

	mov	edi, DWORD PTR [ecx+8]
	mov	ebp, DWORD PTR [ecx+12]
	lea	eax, DWORD PTR [ecx+8]
	mov	esi, edx
	sub	esi, ebx
	mov	DWORD PTR [edi+12], ebp

; 979  :         
; 980  :         // Exhaust
; 981  :         if (remainder_size < MINSIZE)  

	cmp	esi, 16					; 00000010H
	mov	DWORD PTR [ebp+8], edi
	jae	SHORT $L814

; 982  : 	{
; 983  :           set_inuse_bit_at_offset(victim, size);

	mov	esi, DWORD PTR [edx+ecx+4]
	pop	edi
	or	esi, 1
	mov	DWORD PTR [edx+ecx+4], esi
	pop	esi
	pop	ebp
	pop	ebx

; 1125 : }

	pop	ecx
	ret	0
$L814:

; 984  :           return chunk2mem(victim);
; 985  :         }
; 986  :         else 
; 987  : 	{
; 988  :           // Split
; 989  :           remainder = chunk_at_offset(victim, nb);

	lea	edx, DWORD PTR [ecx+ebx]

; 990  :           unsorted_chunks(av)->bk = unsorted_chunks(av)->fd = remainder;
; 991  :           remainder->bk = remainder->fd = unsorted_chunks(av);

	mov	edi, OFFSET FLAT:_mainheap+52
	mov	DWORD PTR _mainheap+60, edx
	mov	DWORD PTR _mainheap+64, edx

; 992  :           set_head(victim, nb | PREV_INUSE);

	or	ebx, 1
	mov	DWORD PTR [edx+8], edi
	mov	DWORD PTR [edx+12], edi
	mov	DWORD PTR [ecx+4], ebx

; 993  :           set_head(remainder, remainder_size | PREV_INUSE);

	mov	ecx, esi
	pop	edi
	or	ecx, 1
	mov	DWORD PTR [edx+4], ecx

; 994  :           set_foot(remainder, remainder_size);

	mov	DWORD PTR [edx+esi], esi
	pop	esi
	pop	ebp
	pop	ebx

; 1125 : }

	pop	ecx
	ret	0
$L1105:

; 897  :       {
; 898  :         // split and reattach remainder
; 899  :         remainder_size = size - nb;

	sub	eax, ebx

; 900  :         remainder = chunk_at_offset(victim, nb);

	lea	ecx, DWORD PTR [edi+ebx]

; 901  :         unsorted_chunks(av)->bk = unsorted_chunks(av)->fd = remainder;
; 902  :         av->last_remainder = remainder; 
; 903  :         remainder->bk = remainder->fd = unsorted_chunks(av);
; 904  :         
; 905  :         set_head(victim, nb | PREV_INUSE);
; 906  :         set_head(remainder, remainder_size | PREV_INUSE);

	mov	edx, eax
	mov	DWORD PTR _mainheap+60, ecx
	mov	DWORD PTR _mainheap+64, ecx
	mov	DWORD PTR _mainheap+48, ecx
	or	ebx, 1
	mov	DWORD PTR [ecx+8], OFFSET FLAT:_mainheap+52
	mov	DWORD PTR [ecx+12], OFFSET FLAT:_mainheap+52
	or	edx, 1
	mov	DWORD PTR [edi+4], ebx
	mov	DWORD PTR [ecx+4], edx

; 907  :         set_foot(remainder, remainder_size);

	mov	DWORD PTR [ecx+eax], eax

; 908  :         
; 909  :         return chunk2mem(victim);

	lea	eax, DWORD PTR [edi+8]
	pop	edi
	pop	esi
	pop	ebp
	pop	ebx

; 1125 : }

	pop	ecx
	ret	0
$L1106:

; 918  :       {
; 919  :         set_inuse_bit_at_offset(victim, size);

	mov	ecx, DWORD PTR [eax+edi+4]
	or	ecx, 1
	mov	DWORD PTR [eax+edi+4], ecx

; 920  :         return chunk2mem(victim);

	lea	eax, DWORD PTR [edi+8]
	pop	edi
	pop	esi
	pop	ebp
	pop	ebx

; 1125 : }

	pop	ecx
	ret	0
$L1109:

; 1101 :     {
; 1102 :       remainder_size = size - nb;
; 1103 :       remainder = chunk_at_offset(victim, nb);
; 1104 :       av->top = remainder;
; 1105 :       set_head(victim, nb | PREV_INUSE);

	mov	esi, ebx
	lea	edx, DWORD PTR [ecx+ebx]
	or	esi, 1
	sub	eax, ebx
	mov	DWORD PTR _mainheap+44, edx
	mov	DWORD PTR [ecx+4], esi

; 1106 :       set_head(remainder, remainder_size | PREV_INUSE);

	or	al, 1
	pop	edi
	pop	esi
	mov	DWORD PTR [edx+4], eax
	pop	ebp
	lea	eax, DWORD PTR [ecx+8]
	pop	ebx

; 1125 : }

	pop	ecx
	ret	0
$L903:

; 1120 :     }
; 1121 :     else 
; 1122 :        // Otherwise, relay to handle system-dependent cases 
; 1123 :       return sysalloc(nb, av);

	push	ebx
	call	_sysalloc
	add	esp, 8
	pop	edi
	pop	esi
	pop	ebp
	pop	ebx

; 1125 : }

	pop	ecx
	ret	0
$L859:

; 1042 :       }
; 1043 :       else 
; 1044 :       {
; 1045 :         size = chunksize(victim);

	mov	esi, DWORD PTR [ecx+4]

; 1046 : 
; 1047 :         //  We know the first chunk in this bin is big enough to use.
; 1048 :         assert(size >= nb);
; 1049 : 
; 1050 :         remainder_size = size - nb;
; 1051 :         
; 1052 :         // Unlink
; 1053 :         bck = victim->bk;

	mov	edi, DWORD PTR [ecx+12]
	and	esi, -4					; fffffffcH

; 1054 :         bin->bk = bck;

	mov	DWORD PTR [edx+12], edi
	mov	eax, esi

; 1055 :         bck->fd = bin;

	mov	DWORD PTR [edi+8], edx
	sub	eax, ebx

; 1056 :         
; 1057 :         // Exhaust
; 1058 :         if (remainder_size < MINSIZE) 

	cmp	eax, 16					; 00000010H
	jae	SHORT $L868

; 1059 : 	{
; 1060 :           set_inuse_bit_at_offset(victim, size);

	mov	eax, DWORD PTR [esi+ecx+4]
	pop	edi
	or	al, 1
	mov	DWORD PTR [esi+ecx+4], eax
	pop	esi
	pop	ebp

; 1078 :           return chunk2mem(victim);

	lea	eax, DWORD PTR [ecx+8]
	pop	ebx

; 1125 : }

	pop	ecx
	ret	0
$L868:

; 1061 :           return chunk2mem(victim);
; 1062 :         }
; 1063 :         else 
; 1064 : 	{
; 1065 :         
; 1066 :           // Split
; 1067 :           remainder = chunk_at_offset(victim, nb);

	lea	edx, DWORD PTR [ecx+ebx]

; 1068 :           
; 1069 :           unsorted_chunks(av)->bk = unsorted_chunks(av)->fd = remainder;
; 1070 :           remainder->bk = remainder->fd = unsorted_chunks(av);

	mov	esi, OFFSET FLAT:_mainheap+52
	mov	DWORD PTR _mainheap+60, edx
	mov	DWORD PTR _mainheap+64, edx

; 1071 :           
; 1072 : 	  // Advertise as last remainder
; 1073 :           if (in_smallbin_range(nb)) av->last_remainder = remainder; 

	cmp	ebx, 512				; 00000200H
	mov	DWORD PTR [edx+8], esi
	mov	DWORD PTR [edx+12], esi
	jae	SHORT $L886
	mov	DWORD PTR _mainheap+48, edx
$L886:

; 1074 :           
; 1075 :           set_head(victim, nb | PREV_INUSE);
; 1076 :           set_head(remainder, remainder_size | PREV_INUSE);

	mov	esi, eax
	or	ebx, 1
	or	esi, 1
	mov	DWORD PTR [ecx+4], ebx
	mov	DWORD PTR [edx+4], esi
	pop	edi
	pop	esi

; 1077 :           set_foot(remainder, remainder_size);

	mov	DWORD PTR [edx+eax], eax
	pop	ebp

; 1078 :           return chunk2mem(victim);

	lea	eax, DWORD PTR [ecx+8]
	pop	ebx

; 1125 : }

	pop	ecx
	ret	0
_heap_alloc ENDP
_TEXT	ENDS
;	COMDAT _heap_consolidate
_TEXT	SEGMENT
_av$ = 8
_fb$ = -12
_maxfb$ = -8
_nextinuse$ = -4
_heap_consolidate PROC NEAR				; COMDAT

; 590  : {

	sub	esp, 12					; 0000000cH
	push	ebx

; 591  :   mfastbinptr *   fb;                 // Current fastbin being consolidated
; 592  :   mfastbinptr *   maxfb;              // Last fastbin (for loop control)
; 593  :   mchunkptr       p;                  // Current chunk being consolidated
; 594  :   mchunkptr       nextp;              // Next chunk to consolidate
; 595  :   mchunkptr       unsorted_bin;       // Bin header
; 596  :   mchunkptr       first_unsorted;     // chunk to link to
; 597  : 
; 598  :   // These have same use as in free()
; 599  :   mchunkptr       nextchunk;
; 600  :   size_t          size;
; 601  :   size_t          nextsize;
; 602  :   size_t          prevsize;
; 603  :   int             nextinuse;
; 604  :   mchunkptr       bck;
; 605  :   mchunkptr       fwd;
; 606  : 
; 607  :   // If max_fast is 0, we know that av hasn't yet been initialized, in which case do so below
; 608  :   if (av->max_fast != 0) 

	mov	ebx, DWORD PTR _av$[esp+12]
	mov	eax, DWORD PTR [ebx]
	test	eax, eax
	je	$L598

; 609  :   {
; 610  :     clear_fastchunks(av);

	or	al, 1
	push	ebp
	mov	DWORD PTR [ebx], eax

; 611  :     unsorted_bin = unsorted_chunks(av);
; 612  : 
; 613  :     // Remove each chunk from fast bin and consolidate it, placing it
; 614  :     // then in unsorted bin. Among other reasons for doing this,
; 615  :     // placing in unsorted bin avoids needing to calculate actual bins
; 616  :     // until malloc is sure that chunks aren't immediately going to be
; 617  :     // reused anyway.
; 618  :     
; 619  :     maxfb = &(av->fastbins[fastbin_index(av->max_fast)]);
; 620  :     fb = &(av->fastbins[0]);

	lea	ecx, DWORD PTR [ebx+4]
	shr	eax, 3
	push	esi
	push	edi
	lea	eax, DWORD PTR [ebx+eax*4-4]
	mov	DWORD PTR _fb$[esp+28], ecx
	mov	DWORD PTR _maxfb$[esp+28], eax
$L603:

; 621  :     do 
; 622  :     {
; 623  :       if ((p = *fb) != 0) 

	mov	eax, DWORD PTR [ecx]
	test	eax, eax
	je	$L609

; 624  :       {
; 625  :         *fb = 0;

	mov	DWORD PTR [ecx], 0
$L607:

; 626  :         
; 627  :         do 
; 628  : 	{
; 629  :           nextp = p->fd;
; 630  :           
; 631  :           // Slightly streamlined version of consolidation code in free()
; 632  :           size = p->size & ~PREV_INUSE;

	mov	edx, DWORD PTR [eax+4]
	mov	ebp, DWORD PTR [eax+8]
	mov	ecx, edx
	and	ecx, -2					; fffffffeH

; 633  :           nextchunk = chunk_at_offset(p, size);
; 634  :           nextsize = chunksize(nextchunk);

	mov	esi, DWORD PTR [ecx+eax+4]
	lea	edi, DWORD PTR [ecx+eax]
	and	esi, -4					; fffffffcH

; 635  :           
; 636  :           if (!prev_inuse(p))

	test	dl, 1
	jne	SHORT $L612

; 637  : 	  {
; 638  :             prevsize = p->prev_size;

	mov	edx, DWORD PTR [eax]

; 639  :             size += prevsize;

	add	ecx, edx

; 640  :             p = chunk_at_offset(p, -((long) prevsize));

	sub	eax, edx

; 641  :             unlink(p, bck, fwd);

	mov	edx, DWORD PTR [eax+8]
	mov	ebx, DWORD PTR [eax+12]
	mov	DWORD PTR [edx+12], ebx
	mov	DWORD PTR [ebx+8], edx
	mov	ebx, DWORD PTR _av$[esp+24]
$L612:

; 642  :           }
; 643  :           
; 644  :           if (nextchunk != av->top) 

	cmp	edi, DWORD PTR [ebx+44]
	je	SHORT $L616

; 645  : 	  {
; 646  :             nextinuse = inuse_bit_at_offset(nextchunk, nextsize);

	mov	edx, DWORD PTR [esi+edi+4]

; 647  :             set_head(nextchunk, nextsize);

	mov	DWORD PTR [edi+4], esi
	and	edx, 1
	mov	DWORD PTR _nextinuse$[esp+28], edx

; 648  :             
; 649  :             if (!nextinuse) 

	jne	SHORT $L619

; 650  : 	    {
; 651  :               size += nextsize;
; 652  :               unlink(nextchunk, bck, fwd);

	mov	edx, DWORD PTR [edi+8]
	mov	edi, DWORD PTR [edi+12]
	add	ecx, esi
	mov	DWORD PTR [edx+12], edi
	mov	DWORD PTR [edi+8], edx
$L619:

; 653  :             }
; 654  :             
; 655  :             first_unsorted = unsorted_bin->fd;

	mov	edx, DWORD PTR [ebx+60]
	lea	esi, DWORD PTR [ebx+52]

; 656  :             unsorted_bin->fd = p;
; 657  :             first_unsorted->bk = p;
; 658  :             
; 659  :             set_head(p, size | PREV_INUSE);

	mov	edi, ecx
	mov	DWORD PTR [esi+8], eax
	or	edi, 1
	mov	DWORD PTR [edx+12], eax
	mov	DWORD PTR [eax+4], edi

; 660  :             p->bk = unsorted_bin;

	mov	DWORD PTR [eax+12], esi

; 661  :             p->fd = first_unsorted;

	mov	DWORD PTR [eax+8], edx

; 662  :             set_foot(p, size);

	mov	DWORD PTR [ecx+eax], ecx

; 663  :           }
; 664  :           else 

	jmp	SHORT $L608
$L616:

; 665  : 	  {
; 666  :             size += nextsize;

	add	esi, ecx

; 667  :             set_head(p, size | PREV_INUSE);

	or	esi, 1
	mov	DWORD PTR [eax+4], esi

; 668  :             av->top = p;

	mov	DWORD PTR [ebx+44], eax
$L608:

; 669  :           }
; 670  :         } while ( (p = nextp) != 0);

	test	ebp, ebp
	mov	eax, ebp
	jne	$L607
	mov	ecx, DWORD PTR _fb$[esp+28]
$L609:

; 671  :       }
; 672  :     } while (fb++ != maxfb);

	mov	edx, DWORD PTR _maxfb$[esp+28]
	mov	eax, ecx
	add	ecx, 4
	cmp	eax, edx
	mov	DWORD PTR _fb$[esp+28], ecx
	jne	$L603
	pop	edi
	pop	esi
	pop	ebp
	pop	ebx

; 676  : }

	add	esp, 12					; 0000000cH
	ret	0
$L598:

; 673  :   }
; 674  :   else 
; 675  :     heap_init(av);

	push	ebx
	call	_heap_init
	add	esp, 4
	pop	ebx

; 676  : }

	add	esp, 12					; 0000000cH
	ret	0
_heap_consolidate ENDP
_TEXT	ENDS
;	COMDAT _heap_init
_TEXT	SEGMENT
_av$ = 8
_heap_init PROC NEAR					; COMDAT

; 554  :   int     i;
; 555  :   mbinptr bin;
; 556  :   
; 557  :   // Establish circular links for normal bins
; 558  :   for (i = 1; i < NBINS; i++)

	mov	ecx, DWORD PTR _av$[esp-4]
	push	esi
	mov	esi, 127				; 0000007fH
	lea	edx, DWORD PTR [ecx+52]
	mov	eax, edx
$L559:

; 559  :   { 
; 560  :     bin = bin_at(av,i);
; 561  :     bin->fd = bin->bk = bin;

	mov	DWORD PTR [eax+12], eax
	mov	DWORD PTR [eax+8], eax
	add	eax, 8
	dec	esi
	jne	SHORT $L559

; 562  :   }
; 563  : 
; 564  :   av->top_pad        = DEFAULT_TOP_PAD;
; 565  :   av->n_mmaps_max    = DEFAULT_MMAP_MAX;
; 566  :   av->mmap_threshold = DEFAULT_MMAP_THRESHOLD;

	mov	eax, 1048576				; 00100000H
	mov	DWORD PTR [ecx+1096], 0
	mov	DWORD PTR [ecx+1100], eax

; 567  :   av->trim_threshold = DEFAULT_TRIM_THRESHOLD;

	mov	DWORD PTR [ecx+1092], eax

; 568  : 
; 569  :   //set_noncontiguous(av);
; 570  : 
; 571  :   set_max_fast(av, DEFAULT_MXFAST);

	mov	eax, DWORD PTR [ecx]
	mov	DWORD PTR [ecx+1108], 65536		; 00010000H
	and	eax, 2

; 572  : 
; 573  :   av->top            = initial_top(av);

	mov	DWORD PTR [ecx+44], edx
	or	al, 73					; 00000049H
	pop	esi
	mov	DWORD PTR [ecx], eax

; 574  : }

	ret	0
_heap_init ENDP
_TEXT	ENDS
PUBLIC	??_C@_0BE@DEG@Big?5allocation?5?$CFdK?6?$AA@	; `string'
PUBLIC	??_C@_0BO@DBPD@unable?5to?5reserve?5heap?5region?$AA@ ; `string'
PUBLIC	??_C@_0DL@IEHD@Expand?5heap?3?5request?5?$DN?5?$CFd?0?5remai@ ; `string'
PUBLIC	??_C@_0O@OAFC@out?5of?5memory?$AA@		; `string'
PUBLIC	??_C@_0BG@HFBC@unable?5to?5expand?5heap?$AA@	; `string'
PUBLIC	??_C@_0BF@CCMK@Reserve?5heap?5region?6?$AA@	; `string'
PUBLIC	??_C@_0BL@HPOG@Expand?5heap?5to?5?$CFd?5KB?5?$CI?$CFd?$CJ?6?$AA@ ; `string'
EXTRN	_panic:NEAR
EXTRN	_syslog:NEAR
EXTRN	_mmap:NEAR
;	COMDAT ??_C@_0BE@DEG@Big?5allocation?5?$CFdK?6?$AA@
; File C:\sanos\emul\src\os\heap.c
_DATA	SEGMENT
??_C@_0BE@DEG@Big?5allocation?5?$CFdK?6?$AA@ DB 'Big allocation %dK', 0aH
	DB	00H						; `string'
_DATA	ENDS
;	COMDAT ??_C@_0BO@DBPD@unable?5to?5reserve?5heap?5region?$AA@
_DATA	SEGMENT
??_C@_0BO@DBPD@unable?5to?5reserve?5heap?5region?$AA@ DB 'unable to reser'
	DB	've heap region', 00H			; `string'
_DATA	ENDS
;	COMDAT ??_C@_0DL@IEHD@Expand?5heap?3?5request?5?$DN?5?$CFd?0?5remai@
_DATA	SEGMENT
??_C@_0DL@IEHD@Expand?5heap?3?5request?5?$DN?5?$CFd?0?5remai@ DB 'Expand '
	DB	'heap: request = %d, remaining = %d, expansion = %d', 0aH, 00H ; `string'
_DATA	ENDS
;	COMDAT ??_C@_0O@OAFC@out?5of?5memory?$AA@
_DATA	SEGMENT
??_C@_0O@OAFC@out?5of?5memory?$AA@ DB 'out of memory', 00H ; `string'
_DATA	ENDS
;	COMDAT ??_C@_0BG@HFBC@unable?5to?5expand?5heap?$AA@
_DATA	SEGMENT
??_C@_0BG@HFBC@unable?5to?5expand?5heap?$AA@ DB 'unable to expand heap', 00H ; `string'
_DATA	ENDS
;	COMDAT ??_C@_0BF@CCMK@Reserve?5heap?5region?6?$AA@
_DATA	SEGMENT
??_C@_0BF@CCMK@Reserve?5heap?5region?6?$AA@ DB 'Reserve heap region', 0aH
	DB	00H						; `string'
_DATA	ENDS
;	COMDAT ??_C@_0BL@HPOG@Expand?5heap?5to?5?$CFd?5KB?5?$CI?$CFd?$CJ?6?$AA@
_DATA	SEGMENT
??_C@_0BL@HPOG@Expand?5heap?5to?5?$CFd?5KB?5?$CI?$CFd?$CJ?6?$AA@ DB 'Expa'
	DB	'nd heap to %d KB (%d)', 0aH, 00H		; `string'
_DATA	ENDS
;	COMDAT _sysalloc
_TEXT	SEGMENT
_nb$ = 8
_av$ = 12
_sysalloc PROC NEAR					; COMDAT

; 693  : {

	push	ebx
	push	ebp

; 694  :   mchunkptr       top;             // incoming value of av->top
; 695  :   size_t          size;            // its size
; 696  :   size_t          newsize;
; 697  :   mchunkptr       p;               // the allocated/returned chunk
; 698  :   mchunkptr       remainder;       // remainder from allocation
; 699  :   unsigned long   remainder_size;  // its size
; 700  :   size_t expand;
; 701  : 
; 702  :   // Allocate big chunks directly from system
; 703  :   if (nb >= av->mmap_threshold && av->n_mmaps < av->n_mmaps_max) 

	mov	ebp, DWORD PTR _av$[esp+4]
	push	esi
	push	edi
	mov	edi, DWORD PTR _nb$[esp+12]
	cmp	edi, DWORD PTR [ebp+1100]
	jb	SHORT $L650
	mov	eax, DWORD PTR [ebp+1104]
	mov	ecx, DWORD PTR [ebp+1108]
	cmp	eax, ecx
	jge	SHORT $L650

; 704  :   {
; 705  :     char *mem;
; 706  : 
; 707  :     size = (nb + sizeof(size_t) + ALIGNMASK + PAGESIZE - 1) & ~(PAGESIZE - 1);

	lea	esi, DWORD PTR [edi+4106]

; 708  : 
; 709  :     mem = (char *) mmap(NULL, size, MEM_COMMIT, PAGE_READWRITE);

	push	4
	and	esi, -4096				; fffff000H
	push	4096					; 00001000H
	push	esi
	push	0
	call	_mmap
	mov	ebx, eax
	add	esp, 16					; 00000010H

; 710  :     if (mem != NULL)

	test	ebx, ebx
	je	SHORT $L650

; 711  :     {
; 712  :       p = (mchunkptr) mem;
; 713  :       set_head(p, size | IS_MMAPPED);

	mov	ecx, esi

; 714  :       syslog(LOG_DEBUG | LOG_HEAP, "Big allocation %dK\n", size / 1024);

	shr	esi, 10					; 0000000aH
	push	esi
	or	ecx, 2
	push	OFFSET FLAT:??_C@_0BE@DEG@Big?5allocation?5?$CFdK?6?$AA@ ; `string'
	push	1073741828				; 40000004H
	mov	DWORD PTR [ebx+4], ecx
	call	_syslog
	add	esp, 12					; 0000000cH

; 715  : 
; 716  :       return chunk2mem(p);

	lea	eax, DWORD PTR [ebx+8]
	pop	edi
	pop	esi
	pop	ebp
	pop	ebx

; 764  : }

	ret	0
$L650:

; 717  :     }
; 718  :   }
; 719  : 
; 720  :   // Allocate memory from the system
; 721  :   if (region == NULL)

	mov	eax, DWORD PTR _region
	test	eax, eax
	jne	SHORT $L657

; 722  :   {
; 723  :     region = (char *) mmap(NULL, REGION_SIZE, MEM_RESERVE, PAGE_READWRITE);

	push	4
	push	8192					; 00002000H
	push	33554432				; 02000000H
	push	0
	call	_mmap
	add	esp, 16					; 00000010H
	mov	DWORD PTR _region, eax

; 724  :     if (!region) panic("unable to reserve heap region");

	test	eax, eax
	jne	SHORT $L660
	push	OFFSET FLAT:??_C@_0BO@DBPD@unable?5to?5reserve?5heap?5region?$AA@ ; `string'
	call	_panic
	mov	eax, DWORD PTR _region
	add	esp, 4
$L660:

; 725  :     wilderness = region;

	mov	DWORD PTR _wilderness, eax

; 726  :     heapend = region + REGION_SIZE;

	add	eax, 33554432				; 02000000H
	mov	DWORD PTR _heapend, eax
$L657:

; 727  :   }
; 728  : 
; 729  :   top = av->top;
; 730  :   size = chunksize(top);

	mov	edx, DWORD PTR [ebp+44]

; 731  : 
; 732  :   // Commit one or more groups from region
; 733  :   expand = (nb + MINSIZE - size + GROUP_SIZE - 1)  & ~(GROUP_SIZE - 1);

	mov	esi, edi
	mov	ebx, DWORD PTR [edx+4]
	and	ebx, -4					; fffffffcH
	sub	esi, ebx
	add	esi, 131087				; 0002000fH
	and	esi, -131072				; fffe0000H

; 734  :   syslog(LOG_HEAP | LOG_DEBUG, "Expand heap: request = %d, remaining = %d, expansion = %d\n", nb, size, expand);

	push	esi
	push	ebx
	push	edi
	push	OFFSET FLAT:??_C@_0DL@IEHD@Expand?5heap?3?5request?5?$DN?5?$CFd?0?5remai@ ; `string'
	push	1073741828				; 40000004H
	call	_syslog

; 735  :   if (wilderness + expand > heapend) panic("out of memory");

	mov	eax, DWORD PTR _wilderness
	mov	ecx, DWORD PTR _heapend
	add	eax, esi
	add	esp, 20					; 00000014H
	cmp	eax, ecx
	jbe	SHORT $L667
	push	OFFSET FLAT:??_C@_0O@OAFC@out?5of?5memory?$AA@ ; `string'
	call	_panic
	add	esp, 4
$L667:

; 736  : 
; 737  :   if (mmap(wilderness, expand, MEM_COMMIT, PAGE_READWRITE) == 0) panic("unable to expand heap");

	mov	ecx, DWORD PTR _wilderness
	push	4
	push	4096					; 00001000H
	push	esi
	push	ecx
	call	_mmap
	add	esp, 16					; 00000010H
	test	eax, eax
	jne	SHORT $L669
	push	OFFSET FLAT:??_C@_0BG@HFBC@unable?5to?5expand?5heap?$AA@ ; `string'
	call	_panic
	add	esp, 4
$L669:

; 738  :   wilderness += expand;

	mov	ecx, DWORD PTR _wilderness
	add	ecx, esi

; 739  : 
; 740  :   if (size == 0)

	test	ebx, ebx
	mov	DWORD PTR _wilderness, ecx
	jne	SHORT $L671

; 741  :   {
; 742  :     syslog(LOG_HEAP | LOG_DEBUG, "Reserve heap region\n");

	push	OFFSET FLAT:??_C@_0BF@CCMK@Reserve?5heap?5region?6?$AA@ ; `string'
	push	1073741828				; 40000004H
	call	_syslog

; 743  :     av->top = (mchunkptr) region;

	mov	edx, DWORD PTR _region
	add	esp, 8
	mov	DWORD PTR [ebp+44], edx

; 744  :     newsize = expand;

	mov	eax, esi

; 745  :   }
; 746  :   else

	jmp	SHORT $L674
$L671:

; 747  :     newsize = size + expand;

	lea	eax, DWORD PTR [esi+ebx]
$L674:

; 748  : 
; 749  :   set_head(av->top, newsize | PREV_INUSE);

	mov	ecx, DWORD PTR [ebp+44]
	or	al, 1

; 750  : 
; 751  :   syslog(LOG_HEAP | LOG_DEBUG, "Expand heap to %d KB (%d)\n", (wilderness - region) / 1024, expand);

	push	esi
	mov	DWORD PTR [ecx+4], eax
	mov	eax, DWORD PTR _wilderness
	sub	eax, DWORD PTR _region
	cdq
	and	edx, 1023				; 000003ffH
	add	eax, edx
	sar	eax, 10					; 0000000aH
	push	eax
	push	OFFSET FLAT:??_C@_0BL@HPOG@Expand?5heap?5to?5?$CFd?5KB?5?$CI?$CFd?$CJ?6?$AA@ ; `string'
	push	1073741828				; 40000004H
	call	_syslog

; 752  : 
; 753  :   // Do the allocation
; 754  :   p = av->top;

	mov	ecx, DWORD PTR [ebp+44]
	add	esp, 16					; 00000010H

; 755  :   size = chunksize(p);

	mov	eax, DWORD PTR [ecx+4]

; 756  : 
; 757  :   remainder_size = size - nb;
; 758  :   remainder = chunk_at_offset(p, nb);

	lea	edx, DWORD PTR [ecx+edi]
	and	al, -4					; fffffffcH

; 759  :   av->top = remainder;

	mov	DWORD PTR [ebp+44], edx
	sub	eax, edi

; 760  :   set_head(p, nb | PREV_INUSE);

	or	edi, 1
	mov	DWORD PTR [ecx+4], edi

; 761  :   set_head(remainder, remainder_size | PREV_INUSE);

	or	al, 1
	pop	edi
	pop	esi
	mov	DWORD PTR [edx+4], eax
	pop	ebp

; 762  : 
; 763  :   return chunk2mem(p);

	lea	eax, DWORD PTR [ecx+8]
	pop	ebx

; 764  : }

	ret	0
_sysalloc ENDP
_TEXT	ENDS
PUBLIC	_heap_free
PUBLIC	??_C@_0BJ@MAPF@Free?5big?5chunk?5?$CFdK?5?$CI?$CFd?$CJ?6?$AA@ ; `string'
EXTRN	_munmap:NEAR
;	COMDAT ??_C@_0BJ@MAPF@Free?5big?5chunk?5?$CFdK?5?$CI?$CFd?$CJ?6?$AA@
; File C:\sanos\emul\src\os\heap.c
_DATA	SEGMENT
??_C@_0BJ@MAPF@Free?5big?5chunk?5?$CFdK?5?$CI?$CFd?$CJ?6?$AA@ DB 'Free bi'
	DB	'g chunk %dK (%d)', 0aH, 00H			; `string'
_DATA	ENDS
;	COMDAT _heap_free
_TEXT	SEGMENT
_mem$ = 8
_nextinuse$ = 8
_heap_free PROC NEAR					; COMDAT

; 1133 :   struct heap *av = get_malloc_state();
; 1134 : 
; 1135 :   mchunkptr       p;           // chunk corresponding to mem
; 1136 :   size_t          size;        // its size
; 1137 :   mfastbinptr*    fb;          // associated fastbin
; 1138 :   mchunkptr       nextchunk;   // next contiguous chunk
; 1139 :   size_t          nextsize;    // its size
; 1140 :   int             nextinuse;   // true if nextchunk is used
; 1141 :   size_t          prevsize;    // size of previous contiguous chunk
; 1142 :   mchunkptr       bck;         // misc temp for linking
; 1143 :   mchunkptr       fwd;         // misc temp for linking
; 1144 : 
; 1145 :   // free(0) has no effect
; 1146 :   if (mem != 0) 

	mov	eax, DWORD PTR _mem$[esp-4]
	push	ebx
	push	esi
	push	edi
	test	eax, eax
	je	$L946

; 1147 :   {
; 1148 :     p = mem2chunk(mem);
; 1149 :     size = chunksize(p);

	mov	edx, DWORD PTR [eax-4]
	lea	esi, DWORD PTR [eax-8]

; 1150 : 
; 1151 :     // If eligible, place chunk on a fastbin so it can be found
; 1152 :     // and used quickly in malloc.
; 1153 : 
; 1154 :     if (size <= av->max_fast) 

	mov	eax, DWORD PTR _mainheap
	mov	edi, edx
	and	edi, -4					; fffffffcH
	cmp	edi, eax
	ja	SHORT $L923

; 1155 :     {
; 1156 : 
; 1157 :       set_fastchunks(av);

	mov	ecx, eax
	and	ecx, -2					; fffffffeH

; 1158 :       fb = &(av->fastbins[fastbin_index(size)]);

	shr	edi, 3
	mov	DWORD PTR _mainheap, ecx

; 1159 :       p->fd = *fb;

	mov	ecx, DWORD PTR _mainheap[edi*4-4]
	lea	eax, DWORD PTR _mainheap[edi*4-4]
	mov	DWORD PTR [esi+8], ecx
	pop	edi

; 1160 :       *fb = p;

	mov	DWORD PTR [eax], esi
	pop	esi
	pop	ebx

; 1250 :       // munmap returns non-zero on failure
; 1251 :       assert(ret == 0);
; 1252 :     }
; 1253 :   }
; 1254 : }

	ret	0
$L923:

; 1161 :     }
; 1162 :     else if (!chunk_is_mmapped(p)) 

	test	dl, 2
	jne	$L926

; 1163 :     {
; 1164 :       // Consolidate other non-mmapped chunks as they arrive.
; 1165 :       nextchunk = chunk_at_offset(p, size);
; 1166 :       nextsize = chunksize(nextchunk);

	mov	eax, DWORD PTR [edi+esi+4]
	lea	ecx, DWORD PTR [edi+esi]
	and	al, -4					; fffffffcH

; 1167 : 
; 1168 :       // Consolidate backward
; 1169 :       if (!prev_inuse(p)) 

	test	dl, 1
	jne	SHORT $L929

; 1170 :       {
; 1171 :         prevsize = p->prev_size;

	mov	edx, DWORD PTR [esi]

; 1172 :         size += prevsize;

	add	edi, edx

; 1173 :         p = chunk_at_offset(p, -((long) prevsize));

	sub	esi, edx

; 1174 :         unlink(p, bck, fwd);

	mov	edx, DWORD PTR [esi+8]
	mov	ebx, DWORD PTR [esi+12]
	mov	DWORD PTR [edx+12], ebx
	mov	DWORD PTR [ebx+8], edx
$L929:

; 1175 :       }
; 1176 : 
; 1177 :       if (nextchunk != av->top) 

	cmp	ecx, DWORD PTR _mainheap+44
	je	SHORT $L933

; 1178 :       {
; 1179 :         // Get and clear inuse bit
; 1180 :         nextinuse = inuse_bit_at_offset(nextchunk, nextsize);

	mov	edx, DWORD PTR [eax+ecx+4]

; 1181 :         set_head(nextchunk, nextsize);

	mov	DWORD PTR [ecx+4], eax
	and	edx, 1
	mov	DWORD PTR _nextinuse$[esp+8], edx

; 1182 : 
; 1183 :         // Consolidate forward 
; 1184 :         if (!nextinuse) 

	jne	SHORT $L936

; 1185 : 	{
; 1186 :           unlink(nextchunk, bck, fwd);

	mov	edx, DWORD PTR [ecx+8]
	mov	ecx, DWORD PTR [ecx+12]

; 1187 :           size += nextsize;

	add	edi, eax
	mov	DWORD PTR [edx+12], ecx
	mov	DWORD PTR [ecx+8], edx
$L936:

; 1188 :         }
; 1189 : 
; 1190 :         // Place the chunk in unsorted chunk list. Chunks are
; 1191 :         // not placed into regular bins until after they have
; 1192 :         // been given one chance to be used in malloc.
; 1193 : 
; 1194 :         bck = unsorted_chunks(av);
; 1195 :         fwd = bck->fd;

	mov	eax, DWORD PTR _mainheap+60

; 1196 :         p->bk = bck;

	mov	DWORD PTR [esi+12], OFFSET FLAT:_mainheap+52

; 1197 :         p->fd = fwd;

	mov	DWORD PTR [esi+8], eax

; 1198 :         bck->fd = p;

	mov	DWORD PTR _mainheap+60, esi

; 1199 :         fwd->bk = p;

	mov	DWORD PTR [eax+12], esi

; 1200 : 
; 1201 :         set_head(p, size | PREV_INUSE);

	mov	eax, edi
	or	al, 1
	mov	DWORD PTR [esi+4], eax

; 1202 :         set_foot(p, size);

	mov	DWORD PTR [edi+esi], edi

; 1203 :       }
; 1204 :       else 

	jmp	SHORT $L942
$L933:

; 1205 :       {
; 1206 : 	// If the chunk borders the current high end of memory,
; 1207 : 	// consolidate into top
; 1208 : 
; 1209 :         size += nextsize;

	add	edi, eax

; 1210 :         set_head(p, size | PREV_INUSE);

	mov	ecx, edi
	or	ecx, 1
	mov	DWORD PTR [esi+4], ecx

; 1211 :         av->top = p;

	mov	DWORD PTR _mainheap+44, esi
$L942:

; 1212 :       }
; 1213 : 
; 1214 :       // If freeing a large space, consolidate possibly-surrounding
; 1215 :       // chunks. Then, if the total unused topmost memory exceeds trim
; 1216 :       // threshold, ask malloc_trim to reduce top.
; 1217 :       // 
; 1218 :       // Unless max_fast is 0, we don't know if there are fastbins
; 1219 :       // bordering top, so we cannot tell for sure whether threshold
; 1220 :       // has been reached unless fastbins are consolidated.  But we
; 1221 :       // don't want to consolidate on each free.  As a compromise,
; 1222 :       // consolidation is performed if FASTBIN_CONSOLIDATION_THRESHOLD
; 1223 :       // is reached.
; 1224 : 
; 1225 :       if (size >= FASTBIN_CONSOLIDATION_THRESHOLD) 

	cmp	edi, 65536				; 00010000H
	jb	SHORT $L946

; 1226 :       { 
; 1227 :         if (have_fastchunks(av)) heap_consolidate(av);

	test	BYTE PTR _mainheap, 1
	jne	SHORT $L944
	push	OFFSET FLAT:_mainheap
	call	_heap_consolidate
	add	esp, 4
$L944:

; 1228 : 
; 1229 :         if (chunksize(av->top) >= av->trim_threshold)

	mov	edx, DWORD PTR _mainheap+44
	mov	ecx, DWORD PTR _mainheap+1092
	mov	eax, DWORD PTR [edx+4]
	and	al, -4					; fffffffcH
	cmp	eax, ecx
	jb	SHORT $L946

; 1230 : 	{
; 1231 :           systrim(av->top_pad, av);

	mov	ecx, DWORD PTR _mainheap+1096
	push	OFFSET FLAT:_mainheap
	push	ecx
	call	_systrim
	add	esp, 8
	pop	edi
	pop	esi
	pop	ebx

; 1250 :       // munmap returns non-zero on failure
; 1251 :       assert(ret == 0);
; 1252 :     }
; 1253 :   }
; 1254 : }

	ret	0
$L926:

; 1232 : 	}
; 1233 :       }
; 1234 : 
; 1235 :     }
; 1236 : 
; 1237 :     // If the chunk was allocated via mmap, release via munmap()
; 1238 :     // Note that if HAVE_MMAP is false but chunk_is_mmapped is
; 1239 :     // true, then user must have overwritten memory. There's nothing
; 1240 :     // we can do to catch this error unless DEBUG is set, in which case
; 1241 :     // check_inuse_chunk (above) will have triggered error.
; 1242 : 
; 1243 :     else 
; 1244 :     {
; 1245 :       int ret;
; 1246 :       size_t offset = p->prev_size;

	mov	ebx, DWORD PTR [esi]

; 1247 :       av->n_mmaps--;

	mov	eax, DWORD PTR _mainheap+1104

; 1248 :       syslog(LOG_DEBUG | LOG_HEAP, "Free big chunk %dK (%d)\n", size / 1024, offset);

	mov	edx, edi
	push	ebx
	shr	edx, 10					; 0000000aH
	push	edx
	dec	eax
	push	OFFSET FLAT:??_C@_0BJ@MAPF@Free?5big?5chunk?5?$CFdK?5?$CI?$CFd?$CJ?6?$AA@ ; `string'
	push	1073741828				; 40000004H
	mov	DWORD PTR _mainheap+1104, eax
	call	_syslog

; 1249 :       ret = munmap(p - offset, size + offset, MEM_RELEASE);

	lea	eax, DWORD PTR [ebx+edi]
	push	32768					; 00008000H
	shl	ebx, 4
	sub	esi, ebx
	push	eax
	push	esi
	call	_munmap
	add	esp, 28					; 0000001cH
$L946:
	pop	edi
	pop	esi
	pop	ebx

; 1250 :       // munmap returns non-zero on failure
; 1251 :       assert(ret == 0);
; 1252 :     }
; 1253 :   }
; 1254 : }

	ret	0
_heap_free ENDP
_TEXT	ENDS
PUBLIC	??_C@_0CG@NNBH@Heap?5Trim?5called?3?5top?5remaining?5@ ; `string'
;	COMDAT ??_C@_0CG@NNBH@Heap?5Trim?5called?3?5top?5remaining?5@
; File C:\sanos\emul\src\os\heap.c
_DATA	SEGMENT
??_C@_0CG@NNBH@Heap?5Trim?5called?3?5top?5remaining?5@ DB 'Heap Trim call'
	DB	'ed: top remaining = %d', 0aH, 00H		; `string'
_DATA	ENDS
;	COMDAT _systrim
_TEXT	SEGMENT
_av$ = 12
_systrim PROC NEAR					; COMDAT

; 777  :   syslog(LOG_HEAP | LOG_DEBUG, "Heap Trim called: top remaining = %d\n", chunksize(av->top));

	mov	eax, DWORD PTR _av$[esp-4]
	mov	ecx, DWORD PTR [eax+44]
	mov	edx, DWORD PTR [ecx+4]
	and	edx, -4					; fffffffcH
	push	edx
	push	OFFSET FLAT:??_C@_0CG@NNBH@Heap?5Trim?5called?3?5top?5remaining?5@ ; `string'
	push	1073741828				; 40000004H
	call	_syslog
	add	esp, 12					; 0000000cH

; 778  :   return 0;

	xor	eax, eax

; 779  : }

	ret	0
_systrim ENDP
_TEXT	ENDS
PUBLIC	_heap_realloc
;	COMDAT _heap_realloc
_TEXT	SEGMENT
_oldmem$ = 8
_bytes$ = 12
_newp$ = 8
_heap_realloc PROC NEAR					; COMDAT

; 1262 :   struct heap *av = get_malloc_state();
; 1263 : 
; 1264 :   size_t           nb;              // padded request size
; 1265 : 
; 1266 :   mchunkptr        oldp;            // chunk corresponding to oldmem
; 1267 :   size_t           oldsize;         // its size
; 1268 : 
; 1269 :   mchunkptr        newp;            // chunk to return
; 1270 :   size_t           newsize;         // its size
; 1271 :   void *           newmem;          // corresponding user mem
; 1272 : 
; 1273 :   mchunkptr        next;            // next contiguous chunk after oldp
; 1274 : 
; 1275 :   mchunkptr        remainder;       // extra space at end of newp
; 1276 :   unsigned long    remainder_size;  // its size
; 1277 : 
; 1278 :   mchunkptr        bck;             // misc temp for linking
; 1279 :   mchunkptr        fwd;             // misc temp for linking
; 1280 : 
; 1281 :   if (bytes == 0)

	mov	eax, DWORD PTR _bytes$[esp-4]
	push	ebx
	push	ebp
	push	esi
	test	eax, eax
	push	edi
	jne	SHORT $L968

; 1282 :   {
; 1283 :     heap_free(oldmem);

	mov	eax, DWORD PTR _oldmem$[esp+12]
	push	eax
	call	_heap_free
	add	esp, 4

; 1284 :     return 0;

	xor	eax, eax
	pop	edi
	pop	esi
	pop	ebp
	pop	ebx

; 1418 :   }
; 1419 : }

	ret	0
$L968:

; 1285 :   }
; 1286 : 
; 1287 :   // Realloc of null is supposed to be same as malloc
; 1288 :   if (oldmem == 0) return heap_alloc(bytes);

	mov	ebp, DWORD PTR _oldmem$[esp+12]
	test	ebp, ebp
	jne	SHORT $L969
	push	eax
	call	_heap_alloc
	add	esp, 4
	pop	edi
	pop	esi
	pop	ebp
	pop	ebx

; 1418 :   }
; 1419 : }

	ret	0
$L969:

; 1289 : 
; 1290 :   nb = request2size(bytes);

	lea	esi, DWORD PTR [eax+11]
	cmp	esi, 16					; 00000010H
	jae	SHORT $L1146
	mov	esi, 16					; 00000010H
	jmp	SHORT $L1147
$L1146:
	and	esi, -8					; fffffff8H
$L1147:

; 1291 : 
; 1292 :   oldp = mem2chunk(oldmem);
; 1293 :   oldsize = chunksize(oldp);

	mov	ecx, DWORD PTR [ebp-4]
	mov	edi, ecx
	and	edi, -4					; fffffffcH

; 1294 : 
; 1295 :   if (!chunk_is_mmapped(oldp)) 

	test	cl, 2
	jne	$L986

; 1296 :   {
; 1297 : 
; 1298 :     if (oldsize >= nb) 

	cmp	edi, esi
	jb	SHORT $L987

; 1299 :     {
; 1300 :       // Already big enough; split below
; 1301 :       newp = oldp;
; 1302 :       newsize = oldsize;

	mov	eax, edi

; 1303 :     }
; 1304 :     else 

	jmp	$L1012
$L987:

; 1305 :     {
; 1306 :       next = chunk_at_offset(oldp, oldsize);
; 1307 : 
; 1308 :       // Try to expand forward into top
; 1309 :       if (next == av->top && (newsize = oldsize + chunksize(next)) >= nb + MINSIZE) 

	mov	eax, DWORD PTR _mainheap+44
	lea	ebx, DWORD PTR [edi+ebp-8]
	cmp	ebx, eax
	mov	eax, DWORD PTR [ebx+4]
	jne	SHORT $L1148
	and	al, -4					; fffffffcH
	lea	edx, DWORD PTR [esi+16]
	add	eax, edi
	cmp	eax, edx
	jb	SHORT $L1004

; 1310 :       {
; 1311 :         set_head_size(oldp, nb);

	and	ecx, 1

; 1312 :         av->top = chunk_at_offset(oldp, nb);
; 1313 :         set_head(av->top, (newsize - nb) | PREV_INUSE);

	sub	eax, esi
	or	ecx, esi
	or	al, 1
	mov	DWORD PTR [ebp-4], ecx
	lea	ecx, DWORD PTR [esi+ebp-8]
	mov	DWORD PTR _mainheap+44, ecx
	pop	edi
	mov	DWORD PTR [ecx+4], eax

; 1314 :         return chunk2mem(oldp);

	lea	eax, DWORD PTR [ebp]
	pop	esi
	pop	ebp
	pop	ebx

; 1418 :   }
; 1419 : }

	ret	0
$L1148:

; 1315 :       }
; 1316 : 
; 1317 :       // Try to expand forward into next chunk;  split off remainder below
; 1318 :       else if (next != av->top && !inuse(next) && (newsize = oldsize + chunksize(next)) >= nb) 

	mov	ecx, eax
	and	ecx, -2					; fffffffeH
	test	BYTE PTR [ecx+ebx+4], 1
	jne	SHORT $L1004
	and	al, -4					; fffffffcH
	add	eax, edi
	cmp	eax, esi
	jb	SHORT $L1004

; 1319 :       {
; 1320 :         newp = oldp;
; 1321 :         unlink(next, bck, fwd);

	mov	ecx, DWORD PTR [ebx+8]
	mov	ebx, DWORD PTR [ebx+12]
	mov	DWORD PTR [ecx+12], ebx
	mov	DWORD PTR [ebx+8], ecx

; 1322 :       }
; 1323 :       else 

	jmp	SHORT $L1012
$L1004:

; 1324 :       {
; 1325 :         // Allocate, copy, free
; 1326 :         newmem = heap_alloc(nb - ALIGNMASK);

	lea	edx, DWORD PTR [esi-7]
	push	edx
	call	_heap_alloc
	add	esp, 4

; 1327 :         if (newmem == 0) return 0; // Propagate failure

	test	eax, eax
	jne	SHORT $L1007
	pop	edi
	pop	esi
	pop	ebp
	pop	ebx

; 1418 :   }
; 1419 : }

	ret	0
$L1007:

; 1328 :       
; 1329 :         newp = mem2chunk(newmem);

	lea	ecx, DWORD PTR [eax-8]

; 1330 :         newsize = chunksize(newp);
; 1331 :         
; 1332 :         // Avoid copy if newp is next chunk after oldp.
; 1333 :         if (newp == next) 

	cmp	ecx, ebx
	mov	DWORD PTR _newp$[esp+12], ecx
	jne	SHORT $L1011
	mov	eax, DWORD PTR [ecx+4]
	and	al, -4					; fffffffcH

; 1334 : 	{
; 1335 :           newsize += oldsize;

	add	eax, edi
$L1012:

; 1343 :         }
; 1344 :       }
; 1345 :     }
; 1346 : 
; 1347 :     // If possible, free extra space in old or extended chunk
; 1348 :     assert(newsize >= nb);
; 1349 :     remainder_size = newsize - nb;

	mov	ecx, eax
	sub	ecx, esi

; 1350 : 
; 1351 :     if (remainder_size < MINSIZE) 

	cmp	ecx, 16					; 00000010H
	jae	SHORT $L1021

; 1352 :     {
; 1353 :       // not enough extra to split off
; 1354 :       set_head_size(newp, newsize);

	mov	ecx, DWORD PTR [ebp-4]
	pop	edi
	and	ecx, 1
	pop	esi
	or	ecx, eax
	mov	DWORD PTR [ebp-4], ecx

; 1355 :       set_inuse_bit_at_offset(newp, newsize);

	mov	ecx, DWORD PTR [eax+ebp-4]
	or	ecx, 1
	mov	DWORD PTR [eax+ebp-4], ecx

; 1367 :     }
; 1368 : 
; 1369 :     return chunk2mem(newp);

	lea	eax, DWORD PTR [ebp]
	pop	ebp
	pop	ebx

; 1418 :   }
; 1419 : }

	ret	0
$L1021:

; 1356 :     }
; 1357 :     else 
; 1358 :     { 
; 1359 :       // split remainder
; 1360 :       remainder = chunk_at_offset(newp, nb);
; 1361 :       set_head_size(newp, nb);

	mov	edx, DWORD PTR [ebp-4]
	lea	eax, DWORD PTR [esi+ebp-8]
	and	edx, 1

; 1362 :       set_head(remainder, remainder_size | PREV_INUSE);
; 1363 :       
; 1364 :       // Mark remainder as inuse so free() won't complain
; 1365 :       set_inuse_bit_at_offset(remainder, remainder_size);
; 1366 :       heap_free(chunk2mem(remainder)); 

	add	eax, 8
	or	edx, esi
	push	eax
	mov	DWORD PTR [ebp-4], edx
	mov	edx, ecx
	or	edx, 1
	mov	DWORD PTR [eax-4], edx
	mov	edx, DWORD PTR [eax+ecx-4]
	or	edx, 1
	mov	DWORD PTR [eax+ecx-4], edx
	call	_heap_free
	add	esp, 4

; 1367 :     }
; 1368 : 
; 1369 :     return chunk2mem(newp);

	lea	eax, DWORD PTR [ebp]
	pop	edi
	pop	esi
	pop	ebp
	pop	ebx

; 1418 :   }
; 1419 : }

	ret	0
$L1011:

; 1336 :           newp = oldp;
; 1337 :         }
; 1338 :         else 
; 1339 : 	{
; 1340 :           memcpy(newmem, oldmem, oldsize - sizeof(size_t));

	lea	ecx, DWORD PTR [edi-4]
	mov	edi, eax
	mov	eax, ecx
	mov	esi, ebp
	shr	ecx, 2
	rep movsd
	mov	ecx, eax

; 1341 :           heap_free(oldmem);

	push	ebp
	and	ecx, 3
	rep movsb
	call	_heap_free

; 1342 :           return chunk2mem(newp);

	mov	ecx, DWORD PTR _newp$[esp+16]
	add	esp, 4
	pop	edi
	pop	esi
	pop	ebp
	lea	eax, DWORD PTR [ecx+8]
	pop	ebx

; 1418 :   }
; 1419 : }

	ret	0
$L986:

; 1370 :   }
; 1371 :   else 
; 1372 :   {
; 1373 :     // Handle mmap cases
; 1374 : #if HAVE_MREMAP
; 1375 :     size_t offset = oldp->prev_size;
; 1376 :     size_t pagemask = av->pagesize - 1;
; 1377 :     char *cp;
; 1378 :     unsigned long sum;
; 1379 :     
; 1380 :     // Note the extra sizeof(size_t) overhead
; 1381 :     newsize = (nb + offset + sizeof(size_t) + pagemask) & ~pagemask;
; 1382 : 
; 1383 :     // don't need to remap if still within same page
; 1384 :     if (oldsize == newsize - offset) return oldmem;
; 1385 : 
; 1386 :     cp = (char *) mremap((char *) oldp - offset, oldsize + offset, newsize, 1);
; 1387 :     if (cp != (char*)MORECORE_FAILURE) 
; 1388 :     {
; 1389 :       newp = (mchunkptr)(cp + offset);
; 1390 :       set_head(newp, (newsize - offset) | IS_MMAPPED);
; 1391 :       
; 1392 :       assert(aligned(chunk2mem(newp)));
; 1393 :       assert((newp->prev_size == offset));
; 1394 :       
; 1395 :       // update statistics
; 1396 :       sum = av->mmapped_mem += newsize - oldsize;
; 1397 :       if (sum > av->max_mmapped_mem) av->max_mmapped_mem = sum;
; 1398 :       sum += av->sbrked_mem;
; 1399 :       if (sum > av->max_total_mem) av->max_total_mem = sum;
; 1400 :       return chunk2mem(newp);
; 1401 :     }
; 1402 : #endif
; 1403 : 
; 1404 :     // Note the extra sizeof(size_t) overhead.
; 1405 :     if (oldsize >= nb + sizeof(size_t)) 

	lea	edx, DWORD PTR [esi+4]
	cmp	edi, edx
	jb	SHORT $L1037

; 1406 :       newmem = oldmem; // do nothing

	mov	ebx, ebp
	pop	edi
	pop	esi

; 1415 :       }
; 1416 :     }
; 1417 :     return newmem;

	mov	eax, ebx
	pop	ebp
	pop	ebx

; 1418 :   }
; 1419 : }

	ret	0
$L1037:

; 1407 :     else 
; 1408 :     {
; 1409 :       // Must alloc, copy, free.
; 1410 :       newmem = heap_alloc(nb - ALIGNMASK);

	add	esi, -7					; fffffff9H
	push	esi
	call	_heap_alloc
	mov	ebx, eax
	add	esp, 4

; 1411 :       if (newmem != 0) 

	test	ebx, ebx
	je	SHORT $L1040

; 1412 :       {
; 1413 :         memcpy(newmem, oldmem, oldsize - 2 * sizeof(size_t));

	lea	ecx, DWORD PTR [edi-8]
	mov	esi, ebp
	mov	eax, ecx
	mov	edi, ebx
	shr	ecx, 2
	rep movsd
	mov	ecx, eax

; 1414 :         heap_free(oldmem);

	push	ebp
	and	ecx, 3
	rep movsb
	call	_heap_free
	add	esp, 4
$L1040:
	pop	edi
	pop	esi

; 1415 :       }
; 1416 :     }
; 1417 :     return newmem;

	mov	eax, ebx
	pop	ebp
	pop	ebx

; 1418 :   }
; 1419 : }

	ret	0
_heap_realloc ENDP
_TEXT	ENDS
PUBLIC	_heap_calloc
;	COMDAT _heap_calloc
_TEXT	SEGMENT
_n_elements$ = 8
_elem_size$ = 12
_heap_calloc PROC NEAR					; COMDAT

; 1427 :   mchunkptr p;
; 1428 : 
; 1429 :   void *mem = heap_alloc(n_elements * elem_size);

	mov	eax, DWORD PTR _n_elements$[esp-4]
	imul	eax, DWORD PTR _elem_size$[esp-4]
	push	eax
	call	_heap_alloc
	mov	edx, eax
	add	esp, 4

; 1430 : 
; 1431 :   if (mem != 0) 

	test	edx, edx
	je	SHORT $L1151

; 1432 :   {
; 1433 :     p = mem2chunk(mem);
; 1434 : 
; 1435 :     // Don't need to clear mmapped space
; 1436 :     if (!chunk_is_mmapped(p))  memset(mem, 0, chunksize(p) - sizeof(size_t));

	mov	ecx, DWORD PTR [edx-4]
	test	cl, 2
	jne	SHORT $L1151
	and	ecx, -4					; fffffffcH
	push	esi
	sub	ecx, 4
	push	edi
	mov	esi, ecx
	xor	eax, eax
	mov	edi, edx
	shr	ecx, 2
	rep stosd
	mov	ecx, esi
	and	ecx, 3
	rep stosb
	pop	edi

; 1437 :   }
; 1438 : 
; 1439 :   return mem;

	mov	eax, edx
	pop	esi

; 1440 : }

	ret	0
$L1151:

; 1437 :   }
; 1438 : 
; 1439 :   return mem;

	mov	eax, edx

; 1440 : }

	ret	0
_heap_calloc ENDP
_TEXT	ENDS
END
