//
// kmem.h
//
// Copyright (c) 2001 Michael Ringgaard. All rights reserved.
//
// Kernel memory page allocator
//

#ifndef KMEM_H
#define KMEM_H

extern struct rmap *osvmap;

void *alloc_pages(int pages);
void *alloc_pages_align(int pages, int align);
void free_pages(void *addr, int pages);
void init_kmem();

#endif
