//
// vmm.h
//
// Copyright (c) 2001 Michael Ringgaard. All rights reserved.
//
// Virtual memory manager
//

#ifndef VMM_H
#define VMM_H

extern struct rmap *vmap;

void init_vmm();

void *mmap(void *addr, unsigned long size, int type, int protect);
int munmap(void *addr, unsigned long size, int type);
void *mremap(void *addr, unsigned long oldsize, unsigned long newsize, int type, int protect);
int mprotect(void *addr, unsigned long size, int protect);
int mlock(void *addr, unsigned long size);
int munlock(void *addr, unsigned long size);

#endif
