//
// syscall.h
//
// Copyright (c) 2001 Michael Ringgaard. All rights reserved.
//
// System call numbers
//

#ifndef SYSCALL_H
#define SYSCALL_H

#define SYSCALL_NULL       0
#define SYSCALL_FORMAT     1
#define SYSCALL_MOUNT      2
#define SYSCALL_UNMOUNT    3
#define SYSCALL_OPEN       4
#define SYSCALL_CLOSE      5
#define SYSCALL_FLUSH      6
#define SYSCALL_READ       7
#define SYSCALL_WRITE      8
#define SYSCALL_TELL       9
#define SYSCALL_LSEEK      10
#define SYSCALL_CHSIZE     11
#define SYSCALL_FSTAT      12
#define SYSCALL_STAT       13
#define SYSCALL_MKDIR      14
#define SYSCALL_RMDIR      15
#define SYSCALL_RENAME     16
#define SYSCALL_LINK       17
#define SYSCALL_UNLINK     18
#define SYSCALL_OPENDIR    19
#define SYSCALL_READDIR    20
#define SYSCALL_MMAP       21
#define SYSCALL_MUNMAP     22
#define SYSCALL_MREMAP     23
#define SYSCALL_MPROTECT   24
#define SYSCALL_MLOCK      25
#define SYSCALL_MUNLOCK    26
#define SYSCALL_WAIT       27
#define SYSCALL_MKEVENT    28
#define SYSCALL_EPULSE     29
#define SYSCALL_ESET       30
#define SYSCALL_ERESET     31
#define SYSCALL_SELF       32
#define SYSCALL_EXIT       33

#endif
